/**
 * @file
 * @brief Function prototypes for the new opcode functions.
 * @note  DO NOT EDIT THIS FILE, your changes will be lost.
 *        Edit libfirm/ir/be/TEMPLATE/TEMPLATE_spec.pl instead.
 *        created by: libfirm/ir/be/scripts/generate_new_opcodes.pl libfirm/ir/be/TEMPLATE/TEMPLATE_spec.pl libfirm/ir/be/TEMPLATE
 * @date  Tue May  4 15:35:37 2010
 */
#ifndef FIRM_BE_TEMPLATE_GEN_TEMPLATE_NEW_NODES_H
#define FIRM_BE_TEMPLATE_GEN_TEMPLATE_NEW_NODES_H

typedef enum _TEMPLATE_opcodes {
	iro_TEMPLATE_fConst,
	iro_TEMPLATE_Shr,
	iro_TEMPLATE_fMul,
	iro_TEMPLATE_Or,
	iro_TEMPLATE_Xor,
	iro_TEMPLATE_fAdd,
	iro_TEMPLATE_Not,
	iro_TEMPLATE_Shl,
	iro_TEMPLATE_fMinus,
	iro_TEMPLATE_Add,
	iro_TEMPLATE_Store,
	iro_TEMPLATE_And,
	iro_TEMPLATE_fStore,
	iro_TEMPLATE_fLoad,
	iro_TEMPLATE_fSub,
	iro_TEMPLATE_Minus,
	iro_TEMPLATE_Const,
	iro_TEMPLATE_fDiv,
	iro_TEMPLATE_Sub,
	iro_TEMPLATE_Load,
	iro_TEMPLATE_Mul,
	iro_TEMPLATE_Jmp,
	iro_TEMPLATE_last_generated,
	iro_TEMPLATE_last = iro_TEMPLATE_last_generated
} TEMPLATE_opcodes;

int is_TEMPLATE_irn(const ir_node *node);
int is_TEMPLATE_op(const ir_op *op);

int get_TEMPLATE_opcode_first(void);
int get_TEMPLATE_opcode_last(void);
int get_TEMPLATE_irn_opcode(const ir_node *node);
void TEMPLATE_create_opcodes(const arch_irn_ops_t *be_ops);
extern ir_op *op_TEMPLATE_fConst;
ir_op *get_op_TEMPLATE_fConst(void);
int is_TEMPLATE_fConst(const ir_node *n);
/**
 * construct fConst node
 */
ir_node *new_bd_TEMPLATE_fConst(dbg_info *dbgi, ir_node *block);

extern ir_op *op_TEMPLATE_Shr;
ir_op *get_op_TEMPLATE_Shr(void);
int is_TEMPLATE_Shr(const ir_node *n);
/**
 * construct Shr node
 */
ir_node *new_bd_TEMPLATE_Shr(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_fMul;
ir_op *get_op_TEMPLATE_fMul(void);
int is_TEMPLATE_fMul(const ir_node *n);
/**
 * construct fMul node
 */
ir_node *new_bd_TEMPLATE_fMul(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_Or;
ir_op *get_op_TEMPLATE_Or(void);
int is_TEMPLATE_Or(const ir_node *n);
/**
 * construct Or node
 */
ir_node *new_bd_TEMPLATE_Or(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_Xor;
ir_op *get_op_TEMPLATE_Xor(void);
int is_TEMPLATE_Xor(const ir_node *n);
/**
 * construct Xor node
 */
ir_node *new_bd_TEMPLATE_Xor(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_fAdd;
ir_op *get_op_TEMPLATE_fAdd(void);
int is_TEMPLATE_fAdd(const ir_node *n);
/**
 * construct fAdd node
 */
ir_node *new_bd_TEMPLATE_fAdd(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_Not;
ir_op *get_op_TEMPLATE_Not(void);
int is_TEMPLATE_Not(const ir_node *n);
/**
 * construct Not node
 */
ir_node *new_bd_TEMPLATE_Not(dbg_info *dbgi, ir_node *block, ir_node *op0);

extern ir_op *op_TEMPLATE_Shl;
ir_op *get_op_TEMPLATE_Shl(void);
int is_TEMPLATE_Shl(const ir_node *n);
/**
 * construct Shl node
 */
ir_node *new_bd_TEMPLATE_Shl(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_fMinus;
ir_op *get_op_TEMPLATE_fMinus(void);
int is_TEMPLATE_fMinus(const ir_node *n);
/**
 * construct fMinus node
 */
ir_node *new_bd_TEMPLATE_fMinus(dbg_info *dbgi, ir_node *block, ir_node *op0);

extern ir_op *op_TEMPLATE_Add;
ir_op *get_op_TEMPLATE_Add(void);
int is_TEMPLATE_Add(const ir_node *n);
/**
 * construct Add node
 */
ir_node *new_bd_TEMPLATE_Add(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_Store;
ir_op *get_op_TEMPLATE_Store(void);
int is_TEMPLATE_Store(const ir_node *n);
/**
 * construct Store node
 */
ir_node *new_bd_TEMPLATE_Store(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2, ir_mode *mode);

extern ir_op *op_TEMPLATE_And;
ir_op *get_op_TEMPLATE_And(void);
int is_TEMPLATE_And(const ir_node *n);
/**
 * construct And node
 */
ir_node *new_bd_TEMPLATE_And(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_fStore;
ir_op *get_op_TEMPLATE_fStore(void);
int is_TEMPLATE_fStore(const ir_node *n);
/**
 * construct fStore node
 */
ir_node *new_bd_TEMPLATE_fStore(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2, ir_mode *mode);

extern ir_op *op_TEMPLATE_fLoad;
ir_op *get_op_TEMPLATE_fLoad(void);
int is_TEMPLATE_fLoad(const ir_node *n);
/**
 * construct fLoad node
 */
ir_node *new_bd_TEMPLATE_fLoad(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *mode);

extern ir_op *op_TEMPLATE_fSub;
ir_op *get_op_TEMPLATE_fSub(void);
int is_TEMPLATE_fSub(const ir_node *n);
/**
 * construct fSub node
 */
ir_node *new_bd_TEMPLATE_fSub(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_Minus;
ir_op *get_op_TEMPLATE_Minus(void);
int is_TEMPLATE_Minus(const ir_node *n);
/**
 * construct Minus node
 */
ir_node *new_bd_TEMPLATE_Minus(dbg_info *dbgi, ir_node *block, ir_node *op0);

extern ir_op *op_TEMPLATE_Const;
ir_op *get_op_TEMPLATE_Const(void);
int is_TEMPLATE_Const(const ir_node *n);
/**
 * construct Const node
 */
ir_node *new_bd_TEMPLATE_Const(dbg_info *dbgi, ir_node *block, tarval *value);

extern ir_op *op_TEMPLATE_fDiv;
ir_op *get_op_TEMPLATE_fDiv(void);
int is_TEMPLATE_fDiv(const ir_node *n);
/**
 * construct fDiv node
 */
ir_node *new_bd_TEMPLATE_fDiv(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_Sub;
ir_op *get_op_TEMPLATE_Sub(void);
int is_TEMPLATE_Sub(const ir_node *n);
/**
 * construct Sub node
 */
ir_node *new_bd_TEMPLATE_Sub(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_Load;
ir_op *get_op_TEMPLATE_Load(void);
int is_TEMPLATE_Load(const ir_node *n);
/**
 * construct Load node
 */
ir_node *new_bd_TEMPLATE_Load(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *mode);

extern ir_op *op_TEMPLATE_Mul;
ir_op *get_op_TEMPLATE_Mul(void);
int is_TEMPLATE_Mul(const ir_node *n);
/**
 * construct Mul node
 */
ir_node *new_bd_TEMPLATE_Mul(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_TEMPLATE_Jmp;
ir_op *get_op_TEMPLATE_Jmp(void);
int is_TEMPLATE_Jmp(const ir_node *n);
/**
 * construct Jmp node
 */
ir_node *new_bd_TEMPLATE_Jmp(dbg_info *dbgi, ir_node *block);




#endif
