/**
 * @file
 * @brief  The generated interface for the register allocator.
 *          Contains register classes and types and register constraints
 *          for all nodes where constraints were given in spec.
 * @note    DO NOT EDIT THIS FILE, your changes will be lost.
 *          Edit libfirm/ir/be/TEMPLATE/TEMPLATE_spec.pl instead.
 *          created by: libfirm/ir/be/scripts/generate_regalloc_if.pl libfirm/ir/be/TEMPLATE/TEMPLATE_spec.pl libfirm/ir/be/TEMPLATE
 * $date    Tue May  4 15:35:37 2010
 */
#include "config.h"

#include "gen_TEMPLATE_regalloc_if.h"
#include "gen_TEMPLATE_machine.h"
#include "bearch_TEMPLATE_t.h"
#include "irmode.h"

static const arch_register_req_t TEMPLATE_class_reg_req_gp;
static const arch_register_req_t TEMPLATE_class_reg_req_fp;

arch_register_class_t TEMPLATE_reg_classes[] = {
	{ 0, "TEMPLATE_gp", N_TEMPLATE_gp_REGS, NULL, TEMPLATE_gp_regs, 0, &TEMPLATE_class_reg_req_gp },
	{ 1, "TEMPLATE_fp", N_TEMPLATE_fp_REGS, NULL, TEMPLATE_fp_regs, 0, &TEMPLATE_class_reg_req_fp }
};

static const arch_register_req_t TEMPLATE_class_reg_req_gp = {
	arch_register_req_type_normal,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	NULL,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r0 [] = { (1 << REG_R0) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r0 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r0,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r1 [] = { (1 << REG_R1) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r1 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r1,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r2 [] = { (1 << REG_R2) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r2 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r2,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r3 [] = { (1 << REG_R3) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r3 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r3,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r4 [] = { (1 << REG_R4) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r4 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r4,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r5 [] = { (1 << REG_R5) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r5 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r5,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r6 [] = { (1 << REG_R6) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r6 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r6,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r7 [] = { (1 << REG_R7) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r7 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r7,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r8 [] = { (1 << REG_R8) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r8 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r8,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r9 [] = { (1 << REG_R9) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r9 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r9,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r10 [] = { (1 << REG_R10) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r10 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r10,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r11 [] = { (1 << REG_R11) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r11 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r11,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r12 [] = { (1 << REG_R12) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r12 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r12,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_r13 [] = { (1 << REG_R13) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_r13 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_r13,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_sp [] = { (1 << REG_SP) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_sp = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_sp,
	0,
	0
};
static const unsigned TEMPLATE_limited_gp_bp [] = { (1 << REG_BP) };
static const arch_register_req_t TEMPLATE_single_reg_req_gp_bp = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
	TEMPLATE_limited_gp_bp,
	0,
	0
};
static const arch_register_req_t TEMPLATE_class_reg_req_fp = {
	arch_register_req_type_normal,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	NULL,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f0 [] = { (1 << REG_F0) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f0 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f0,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f1 [] = { (1 << REG_F1) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f1 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f1,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f2 [] = { (1 << REG_F2) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f2 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f2,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f3 [] = { (1 << REG_F3) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f3 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f3,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f4 [] = { (1 << REG_F4) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f4 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f4,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f5 [] = { (1 << REG_F5) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f5 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f5,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f6 [] = { (1 << REG_F6) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f6 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f6,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f7 [] = { (1 << REG_F7) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f7 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f7,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f8 [] = { (1 << REG_F8) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f8 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f8,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f9 [] = { (1 << REG_F9) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f9 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f9,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f10 [] = { (1 << REG_F10) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f10 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f10,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f11 [] = { (1 << REG_F11) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f11 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f11,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f12 [] = { (1 << REG_F12) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f12 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f12,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f13 [] = { (1 << REG_F13) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f13 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f13,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f14 [] = { (1 << REG_F14) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f14 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f14,
	0,
	0
};
static const unsigned TEMPLATE_limited_fp_f15 [] = { (1 << REG_F15) };
static const arch_register_req_t TEMPLATE_single_reg_req_fp_f15 = {
	arch_register_req_type_limited,
	&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
	TEMPLATE_limited_fp_f15,
	0,
	0
};

const arch_register_t TEMPLATE_gp_regs[N_TEMPLATE_gp_REGS] = {
	{
		"r0",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R0,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_gp_r0
	},
	{
		"r1",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R1,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_gp_r1
	},
	{
		"r2",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R2,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_gp_r2
	},
	{
		"r3",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R3,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_gp_r3
	},
	{
		"r4",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R4,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_gp_r4
	},
	{
		"r5",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R5,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_gp_r5
	},
	{
		"r6",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R6,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_gp_r6
	},
	{
		"r7",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R7,
		arch_register_type_callee_save,
		&TEMPLATE_single_reg_req_gp_r7
	},
	{
		"r8",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R8,
		arch_register_type_callee_save,
		&TEMPLATE_single_reg_req_gp_r8
	},
	{
		"r9",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R9,
		arch_register_type_callee_save,
		&TEMPLATE_single_reg_req_gp_r9
	},
	{
		"r10",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R10,
		arch_register_type_callee_save,
		&TEMPLATE_single_reg_req_gp_r10
	},
	{
		"r11",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R11,
		arch_register_type_callee_save,
		&TEMPLATE_single_reg_req_gp_r11
	},
	{
		"r12",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R12,
		arch_register_type_callee_save,
		&TEMPLATE_single_reg_req_gp_r12
	},
	{
		"r13",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_R13,
		arch_register_type_callee_save,
		&TEMPLATE_single_reg_req_gp_r13
	},
	{
		"r14",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_SP,
		arch_register_type_ignore,
		&TEMPLATE_single_reg_req_gp_sp
	},
	{
		"r15",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_gp],
		REG_BP,
		arch_register_type_ignore,
		&TEMPLATE_single_reg_req_gp_bp
	},
};
const arch_register_t TEMPLATE_fp_regs[N_TEMPLATE_fp_REGS] = {
	{
		"f0",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F0,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f0
	},
	{
		"f1",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F1,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f1
	},
	{
		"f2",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F2,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f2
	},
	{
		"f3",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F3,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f3
	},
	{
		"f4",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F4,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f4
	},
	{
		"f5",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F5,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f5
	},
	{
		"f6",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F6,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f6
	},
	{
		"f7",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F7,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f7
	},
	{
		"f8",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F8,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f8
	},
	{
		"f9",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F9,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f9
	},
	{
		"f10",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F10,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f10
	},
	{
		"f11",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F11,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f11
	},
	{
		"f12",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F12,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f12
	},
	{
		"f13",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F13,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f13
	},
	{
		"f14",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F14,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f14
	},
	{
		"f15",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_fp],
		REG_F15,
		arch_register_type_caller_save,
		&TEMPLATE_single_reg_req_fp_f15
	},
};


void TEMPLATE_register_init(void)
{
	TEMPLATE_reg_classes[CLASS_TEMPLATE_gp].mode = mode_Iu;
	TEMPLATE_reg_classes[CLASS_TEMPLATE_fp].mode = mode_E;

}
