/**
 * @file
 * @brief Function prototypes for the new opcode functions.
 * @note  DO NOT EDIT THIS FILE, your changes will be lost.
 *        Edit libfirm/ir/be/amd64/amd64_spec.pl instead.
 *        created by: libfirm/ir/be/scripts/generate_new_opcodes.pl libfirm/ir/be/amd64/amd64_spec.pl libfirm/ir/be/amd64
 * @date  Tue May  4 15:35:32 2010
 */
#ifndef FIRM_BE_AMD64_GEN_AMD64_NEW_NODES_H
#define FIRM_BE_AMD64_GEN_AMD64_NEW_NODES_H

typedef enum _amd64_opcodes {
	iro_amd64_Push,
	iro_amd64_Add,
	iro_amd64_Immediate,
	iro_amd64_last_generated,
	iro_amd64_last = iro_amd64_last_generated
} amd64_opcodes;

int is_amd64_irn(const ir_node *node);
int is_amd64_op(const ir_op *op);

int get_amd64_opcode_first(void);
int get_amd64_opcode_last(void);
int get_amd64_irn_opcode(const ir_node *node);
void amd64_create_opcodes(const arch_irn_ops_t *be_ops);
extern ir_op *op_amd64_Push;
ir_op *get_op_amd64_Push(void);
int is_amd64_Push(const ir_node *n);
/**
 * construct Push node
 */
ir_node *new_bd_amd64_Push(dbg_info *dbgi, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val, ir_node *stack);

extern ir_op *op_amd64_Add;
ir_op *get_op_amd64_Add(void);
int is_amd64_Add(const ir_node *n);
/**
 * construct Add node
 */
ir_node *new_bd_amd64_Add(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_amd64_Immediate;
ir_op *get_op_amd64_Immediate(void);
int is_amd64_Immediate(const ir_node *n);
/**
 * construct Immediate node
 */
ir_node *new_bd_amd64_Immediate(dbg_info *dbgi, ir_node *block, unsigned imm_value);



enum pn_amd64_Push {
	pn_amd64_Push_stack = 0,
	pn_amd64_Push_M = 1,
};

enum n_amd64_Push {
	n_amd64_Push_base = 0,
	n_amd64_Push_index = 1,
	n_amd64_Push_mem = 2,
	n_amd64_Push_val = 3,
	n_amd64_Push_stack = 4,
};

enum pn_amd64_Add {
	pn_amd64_Add_res = 0,
};


#endif
