/**
 * @file
 * @brief  The generated interface for the register allocator.
 *          Contains register classes and types and register constraints
 *          for all nodes where constraints were given in spec.
 * @note    DO NOT EDIT THIS FILE, your changes will be lost.
 *          Edit libfirm/ir/be/amd64/amd64_spec.pl instead.
 *          created by: libfirm/ir/be/scripts/generate_regalloc_if.pl libfirm/ir/be/amd64/amd64_spec.pl libfirm/ir/be/amd64
 * $date    Tue May  4 15:35:32 2010
 */
#include "config.h"

#include "gen_amd64_regalloc_if.h"
#include "gen_amd64_machine.h"
#include "bearch_amd64_t.h"
#include "irmode.h"

static const arch_register_req_t amd64_class_reg_req_gp;
static const arch_register_req_t amd64_class_reg_req_fp;

arch_register_class_t amd64_reg_classes[] = {
	{ 0, "amd64_gp", N_amd64_gp_REGS, NULL, amd64_gp_regs, 0, &amd64_class_reg_req_gp },
	{ 1, "amd64_fp", N_amd64_fp_REGS, NULL, amd64_fp_regs, 0, &amd64_class_reg_req_fp }
};

static const arch_register_req_t amd64_class_reg_req_gp = {
	arch_register_req_type_normal,
	&amd64_reg_classes[CLASS_amd64_gp],
	NULL,
	0,
	0
};
static const unsigned amd64_limited_gp_rax [] = { (1 << REG_RAX) };
static const arch_register_req_t amd64_single_reg_req_gp_rax = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_rax,
	0,
	0
};
static const unsigned amd64_limited_gp_rcx [] = { (1 << REG_RCX) };
static const arch_register_req_t amd64_single_reg_req_gp_rcx = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_rcx,
	0,
	0
};
static const unsigned amd64_limited_gp_rdx [] = { (1 << REG_RDX) };
static const arch_register_req_t amd64_single_reg_req_gp_rdx = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_rdx,
	0,
	0
};
static const unsigned amd64_limited_gp_rbx [] = { (1 << REG_RBX) };
static const arch_register_req_t amd64_single_reg_req_gp_rbx = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_rbx,
	0,
	0
};
static const unsigned amd64_limited_gp_rsi [] = { (1 << REG_RSI) };
static const arch_register_req_t amd64_single_reg_req_gp_rsi = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_rsi,
	0,
	0
};
static const unsigned amd64_limited_gp_rdi [] = { (1 << REG_RDI) };
static const arch_register_req_t amd64_single_reg_req_gp_rdi = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_rdi,
	0,
	0
};
static const unsigned amd64_limited_gp_rbp [] = { (1 << REG_RBP) };
static const arch_register_req_t amd64_single_reg_req_gp_rbp = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_rbp,
	0,
	0
};
static const unsigned amd64_limited_gp_rsp [] = { (1 << REG_RSP) };
static const arch_register_req_t amd64_single_reg_req_gp_rsp = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_rsp,
	0,
	0
};
static const unsigned amd64_limited_gp_r8 [] = { (1 << REG_R8) };
static const arch_register_req_t amd64_single_reg_req_gp_r8 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_r8,
	0,
	0
};
static const unsigned amd64_limited_gp_r9 [] = { (1 << REG_R9) };
static const arch_register_req_t amd64_single_reg_req_gp_r9 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_r9,
	0,
	0
};
static const unsigned amd64_limited_gp_r10 [] = { (1 << REG_R10) };
static const arch_register_req_t amd64_single_reg_req_gp_r10 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_r10,
	0,
	0
};
static const unsigned amd64_limited_gp_r11 [] = { (1 << REG_R11) };
static const arch_register_req_t amd64_single_reg_req_gp_r11 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_r11,
	0,
	0
};
static const unsigned amd64_limited_gp_r12 [] = { (1 << REG_R12) };
static const arch_register_req_t amd64_single_reg_req_gp_r12 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_r12,
	0,
	0
};
static const unsigned amd64_limited_gp_r13 [] = { (1 << REG_R13) };
static const arch_register_req_t amd64_single_reg_req_gp_r13 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_r13,
	0,
	0
};
static const unsigned amd64_limited_gp_r14 [] = { (1 << REG_R14) };
static const arch_register_req_t amd64_single_reg_req_gp_r14 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_r14,
	0,
	0
};
static const unsigned amd64_limited_gp_r15 [] = { (1 << REG_R15) };
static const arch_register_req_t amd64_single_reg_req_gp_r15 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_gp],
	amd64_limited_gp_r15,
	0,
	0
};
static const arch_register_req_t amd64_class_reg_req_fp = {
	arch_register_req_type_normal,
	&amd64_reg_classes[CLASS_amd64_fp],
	NULL,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm0 [] = { (1 << REG_XMM0) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm0 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm0,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm1 [] = { (1 << REG_XMM1) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm1 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm1,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm2 [] = { (1 << REG_XMM2) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm2 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm2,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm3 [] = { (1 << REG_XMM3) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm3 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm3,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm4 [] = { (1 << REG_XMM4) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm4 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm4,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm5 [] = { (1 << REG_XMM5) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm5 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm5,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm6 [] = { (1 << REG_XMM6) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm6 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm6,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm7 [] = { (1 << REG_XMM7) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm7 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm7,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm8 [] = { (1 << REG_XMM8) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm8 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm8,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm9 [] = { (1 << REG_XMM9) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm9 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm9,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm10 [] = { (1 << REG_XMM10) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm10 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm10,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm11 [] = { (1 << REG_XMM11) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm11 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm11,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm12 [] = { (1 << REG_XMM12) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm12 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm12,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm13 [] = { (1 << REG_XMM13) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm13 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm13,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm14 [] = { (1 << REG_XMM14) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm14 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm14,
	0,
	0
};
static const unsigned amd64_limited_fp_xmm15 [] = { (1 << REG_XMM15) };
static const arch_register_req_t amd64_single_reg_req_fp_xmm15 = {
	arch_register_req_type_limited,
	&amd64_reg_classes[CLASS_amd64_fp],
	amd64_limited_fp_xmm15,
	0,
	0
};

const arch_register_t amd64_gp_regs[N_amd64_gp_REGS] = {
	{
		"rax",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_RAX,
		arch_register_type_caller_save,
		&amd64_single_reg_req_gp_rax
	},
	{
		"rcx",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_RCX,
		arch_register_type_caller_save,
		&amd64_single_reg_req_gp_rcx
	},
	{
		"rdx",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_RDX,
		arch_register_type_caller_save,
		&amd64_single_reg_req_gp_rdx
	},
	{
		"rbx",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_RBX,
		arch_register_type_callee_save,
		&amd64_single_reg_req_gp_rbx
	},
	{
		"rsi",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_RSI,
		arch_register_type_callee_save,
		&amd64_single_reg_req_gp_rsi
	},
	{
		"rdi",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_RDI,
		arch_register_type_callee_save,
		&amd64_single_reg_req_gp_rdi
	},
	{
		"rbp",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_RBP,
		arch_register_type_callee_save,
		&amd64_single_reg_req_gp_rbp
	},
	{
		"rsp",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_RSP,
		arch_register_type_ignore,
		&amd64_single_reg_req_gp_rsp
	},
	{
		"r8",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_R8,
		arch_register_type_caller_save,
		&amd64_single_reg_req_gp_r8
	},
	{
		"r9",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_R9,
		arch_register_type_caller_save,
		&amd64_single_reg_req_gp_r9
	},
	{
		"r10",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_R10,
		arch_register_type_caller_save,
		&amd64_single_reg_req_gp_r10
	},
	{
		"r11",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_R11,
		arch_register_type_caller_save,
		&amd64_single_reg_req_gp_r11
	},
	{
		"r12",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_R12,
		arch_register_type_callee_save,
		&amd64_single_reg_req_gp_r12
	},
	{
		"r13",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_R13,
		arch_register_type_callee_save,
		&amd64_single_reg_req_gp_r13
	},
	{
		"r14",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_R14,
		arch_register_type_callee_save,
		&amd64_single_reg_req_gp_r14
	},
	{
		"r15",
		&amd64_reg_classes[CLASS_amd64_gp],
		REG_R15,
		arch_register_type_callee_save,
		&amd64_single_reg_req_gp_r15
	},
};
const arch_register_t amd64_fp_regs[N_amd64_fp_REGS] = {
	{
		"xmm0",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM0,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm0
	},
	{
		"xmm1",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM1,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm1
	},
	{
		"xmm2",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM2,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm2
	},
	{
		"xmm3",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM3,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm3
	},
	{
		"xmm4",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM4,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm4
	},
	{
		"xmm5",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM5,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm5
	},
	{
		"xmm6",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM6,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm6
	},
	{
		"xmm7",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM7,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm7
	},
	{
		"xmm8",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM8,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm8
	},
	{
		"xmm9",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM9,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm9
	},
	{
		"xmm10",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM10,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm10
	},
	{
		"xmm11",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM11,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm11
	},
	{
		"xmm12",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM12,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm12
	},
	{
		"xmm13",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM13,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm13
	},
	{
		"xmm14",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM14,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm14
	},
	{
		"xmm15",
		&amd64_reg_classes[CLASS_amd64_fp],
		REG_XMM15,
		arch_register_type_caller_save,
		&amd64_single_reg_req_fp_xmm15
	},
};


void amd64_register_init(void)
{
	amd64_reg_classes[CLASS_amd64_gp].mode = mode_Iu;
	amd64_reg_classes[CLASS_amd64_fp].mode = mode_D;

}
