/**
 * @file
 * @brief Contains additional external requirements defs for external includes.
 * @note   DO NOT EDIT THIS FILE, your changes will be lost.
 *         Edit libfirm/ir/be/amd64/amd64_spec.pl instead.
 *         created by: libfirm/ir/be/scripts/generate_regalloc_if.pl libfirm/ir/be/amd64/amd64_spec.pl libfirm/ir/be/amd64
 * @date   Tue May  4 15:35:32 2010
 */
#ifndef FIRM_BE_AMD64_GEN_AMD64_REGALLOC_IF_H
#define FIRM_BE_AMD64_GEN_AMD64_REGALLOC_IF_H

#include "../bearch.h"
#include "amd64_nodes_attr.h"

enum reg_amd64_gp_indices {
	REG_RAX,
	REG_RCX,
	REG_RDX,
	REG_RBX,
	REG_RSI,
	REG_RDI,
	REG_RBP,
	REG_RSP,
	REG_R8,
	REG_R9,
	REG_R10,
	REG_R11,
	REG_R12,
	REG_R13,
	REG_R14,
	REG_R15,
	N_amd64_gp_REGS = 16
};

enum reg_amd64_fp_indices {
	REG_XMM0,
	REG_XMM1,
	REG_XMM2,
	REG_XMM3,
	REG_XMM4,
	REG_XMM5,
	REG_XMM6,
	REG_XMM7,
	REG_XMM8,
	REG_XMM9,
	REG_XMM10,
	REG_XMM11,
	REG_XMM12,
	REG_XMM13,
	REG_XMM14,
	REG_XMM15,
	N_amd64_fp_REGS = 16
};


enum reg_classes {
	CLASS_amd64_gp = 0,
	CLASS_amd64_fp = 1,
	N_CLASSES = 2
};


extern const arch_register_t amd64_gp_regs[N_amd64_gp_REGS];
extern const arch_register_t amd64_fp_regs[N_amd64_fp_REGS];


extern arch_register_class_t amd64_reg_classes[N_CLASSES];

void amd64_register_init(void);
unsigned amd64_get_n_regs(void);

#endif
