/**
 * @file
 * @brief Function prototypes for the new opcode functions.
 * @note  DO NOT EDIT THIS FILE, your changes will be lost.
 *        Edit libfirm/ir/be/arm/arm_spec.pl instead.
 *        created by: libfirm/ir/be/scripts/generate_new_opcodes.pl libfirm/ir/be/arm/arm_spec.pl libfirm/ir/be/arm
 * @date  Tue May  4 15:35:34 2010
 */
#ifndef FIRM_BE_ARM_GEN_ARM_NEW_NODES_H
#define FIRM_BE_ARM_GEN_ARM_NEW_NODES_H

typedef enum _arm_opcodes {
	iro_arm_Ldr,
	iro_arm_Rsb,
	iro_arm_Mla,
	iro_arm_fpaLdf,
	iro_arm_fpaAbs,
	iro_arm_fpaMin,
	iro_arm_fpaConst,
	iro_arm_fpaFrd,
	iro_arm_Mov,
	iro_arm_fpaFdv,
	iro_arm_LdTls,
	iro_arm_Or,
	iro_arm_SubSPandCopy,
	iro_arm_EmptyReg,
	iro_arm_Cmp,
	iro_arm_fpaMax,
	iro_arm_fpaRdf,
	iro_arm_Smull,
	iro_arm_Add,
	iro_arm_fpaFix,
	iro_arm_fpaMvf,
	iro_arm_fpaCnfeBra,
	iro_arm_Mvn,
	iro_arm_Abs,
	iro_arm_B,
	iro_arm_LoadStackM3Epilogue,
	iro_arm_Tst,
	iro_arm_Umull,
	iro_arm_Bic,
	iro_arm_Sub,
	iro_arm_Mul,
	iro_arm_fpaRsf,
	iro_arm_fpaMnf,
	iro_arm_fpaFml,
	iro_arm_fpaSuf,
	iro_arm_fpaDbl2GP,
	iro_arm_CopyB,
	iro_arm_AddSP,
	iro_arm_fpaAdf,
	iro_arm_fpaCmfBra,
	iro_arm_fpaStf,
	iro_arm_FrameAddr,
	iro_arm_And,
	iro_arm_Str,
	iro_arm_fpaFlt,
	iro_arm_fpaDvf,
	iro_arm_SwitchJmp,
	iro_arm_StoreStackM4Inc,
	iro_arm_SymConst,
	iro_arm_fpaMuf,
	iro_arm_Eor,
	iro_arm_fpaCmfeBra,
	iro_arm_fpaCnfBra,
	iro_arm_Jmp,
	iro_arm_last_generated,
	iro_arm_last = iro_arm_last_generated
} arm_opcodes;

int is_arm_irn(const ir_node *node);
int is_arm_op(const ir_op *op);

int get_arm_opcode_first(void);
int get_arm_opcode_last(void);
int get_arm_irn_opcode(const ir_node *node);
void arm_create_opcodes(const arch_irn_ops_t *be_ops);
extern ir_op *op_arm_Ldr;
ir_op *get_op_arm_Ldr(void);
int is_arm_Ldr(const ir_node *n);
/**
 * construct Ldr node
 */
ir_node *new_bd_arm_Ldr(dbg_info *dbgi, ir_node *block, ir_node *ptr, ir_node *mem, ir_mode *ls_mode, ir_entity *entity, int entity_sign, long offset, bool is_frame_entity);

extern ir_op *op_arm_Rsb;
ir_op *get_op_arm_Rsb(void);
int is_arm_Rsb(const ir_node *n);
/**
 * construct Rsb node
 */
ir_node *new_bd_arm_Rsb_imm(dbg_info *dbgi, ir_node *block, ir_node *left, unsigned char immediate_value, unsigned char immediate_rot);
/**
 * construct Rsb node
 */
ir_node *new_bd_arm_Rsb_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, arm_shift_modifier shift_modifier, unsigned shift_immediate);
/**
 * construct Rsb node
 */
ir_node *new_bd_arm_Rsb_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);
/**
 * construct Rsb node
 */
ir_node *new_bd_arm_Rsb_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, ir_node *shift, arm_shift_modifier shift_modifier);

extern ir_op *op_arm_Mla;
ir_op *get_op_arm_Mla(void);
int is_arm_Mla(const ir_node *n);
/**
 * construct Mla node
 */
ir_node *new_bd_arm_Mla(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2);

extern ir_op *op_arm_fpaLdf;
ir_op *get_op_arm_fpaLdf(void);
int is_arm_fpaLdf(const ir_node *n);
/**
 * construct fpaLdf node
 */
ir_node *new_bd_arm_fpaLdf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *op_mode);

extern ir_op *op_arm_fpaAbs;
ir_op *get_op_arm_fpaAbs(void);
int is_arm_fpaAbs(const ir_node *n);
/**
 * construct fpaAbs node
 */
ir_node *new_bd_arm_fpaAbs(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_mode *mode);

extern ir_op *op_arm_fpaMin;
ir_op *get_op_arm_fpaMin(void);
int is_arm_fpaMin(const ir_node *n);
/**
 * construct fpaMin node
 */
ir_node *new_bd_arm_fpaMin(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *mode);

extern ir_op *op_arm_fpaConst;
ir_op *get_op_arm_fpaConst(void);
int is_arm_fpaConst(const ir_node *n);
/**
 * construct fpaConst node
 */
ir_node *new_bd_arm_fpaConst(dbg_info *dbgi, ir_node *block, tarval *tv);

extern ir_op *op_arm_fpaFrd;
ir_op *get_op_arm_fpaFrd(void);
int is_arm_fpaFrd(const ir_node *n);
/**
 * construct fpaFrd node
 */
ir_node *new_bd_arm_fpaFrd(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *op_mode);

extern ir_op *op_arm_Mov;
ir_op *get_op_arm_Mov(void);
int is_arm_Mov(const ir_node *n);
/**
 * construct Mov node
 */
ir_node *new_bd_arm_Mov_imm(dbg_info *dbgi, ir_node *block, unsigned char immediate_value, unsigned char immediate_rot);
/**
 * construct Mov node
 */
ir_node *new_bd_arm_Mov_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *op0, arm_shift_modifier shift_modifier, unsigned shift_immediate);
/**
 * construct Mov node
 */
ir_node *new_bd_arm_Mov_reg(dbg_info *dbgi, ir_node *block, ir_node *op0);
/**
 * construct Mov node
 */
ir_node *new_bd_arm_Mov_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, arm_shift_modifier shift_modifier);

extern ir_op *op_arm_fpaFdv;
ir_op *get_op_arm_fpaFdv(void);
int is_arm_fpaFdv(const ir_node *n);
/**
 * construct fpaFdv node
 */
ir_node *new_bd_arm_fpaFdv(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *op_mode);

extern ir_op *op_arm_LdTls;
ir_op *get_op_arm_LdTls(void);
int is_arm_LdTls(const ir_node *n);
/**
 * construct LdTls node
 */
ir_node *new_bd_arm_LdTls(dbg_info *dbgi, ir_node *block, ir_mode *mode);

extern ir_op *op_arm_Or;
ir_op *get_op_arm_Or(void);
int is_arm_Or(const ir_node *n);
/**
 * construct Or node
 */
ir_node *new_bd_arm_Or_imm(dbg_info *dbgi, ir_node *block, ir_node *left, unsigned char immediate_value, unsigned char immediate_rot);
/**
 * construct Or node
 */
ir_node *new_bd_arm_Or_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, arm_shift_modifier shift_modifier, unsigned shift_immediate);
/**
 * construct Or node
 */
ir_node *new_bd_arm_Or_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);
/**
 * construct Or node
 */
ir_node *new_bd_arm_Or_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, ir_node *shift, arm_shift_modifier shift_modifier);

extern ir_op *op_arm_SubSPandCopy;
ir_op *get_op_arm_SubSPandCopy(void);
int is_arm_SubSPandCopy(const ir_node *n);
/**
 * construct SubSPandCopy node
 */
ir_node *new_bd_arm_SubSPandCopy(dbg_info *dbgi, ir_node *block, ir_node *stack, ir_node *size, ir_node *mem);

extern ir_op *op_arm_EmptyReg;
ir_op *get_op_arm_EmptyReg(void);
int is_arm_EmptyReg(const ir_node *n);
/**
 * construct EmptyReg node
 */
ir_node *new_bd_arm_EmptyReg(dbg_info *dbgi, ir_node *block);

extern ir_op *op_arm_Cmp;
ir_op *get_op_arm_Cmp(void);
int is_arm_Cmp(const ir_node *n);
/**
 * construct Cmp node
 */
ir_node *new_bd_arm_Cmp_imm(dbg_info *dbgi, ir_node *block, ir_node *left, unsigned char immediate_value, unsigned char immediate_rot, bool ins_permuted, bool is_unsigned);
/**
 * construct Cmp node
 */
ir_node *new_bd_arm_Cmp_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, arm_shift_modifier shift_modifier, unsigned shift_immediate, bool ins_permuted, bool is_unsigned);
/**
 * construct Cmp node
 */
ir_node *new_bd_arm_Cmp_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, bool ins_permuted, bool is_unsigned);
/**
 * construct Cmp node
 */
ir_node *new_bd_arm_Cmp_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, ir_node *shift, arm_shift_modifier shift_modifier, bool ins_permuted, bool is_unsigned);

extern ir_op *op_arm_fpaMax;
ir_op *get_op_arm_fpaMax(void);
int is_arm_fpaMax(const ir_node *n);
/**
 * construct fpaMax node
 */
ir_node *new_bd_arm_fpaMax(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *mode);

extern ir_op *op_arm_fpaRdf;
ir_op *get_op_arm_fpaRdf(void);
int is_arm_fpaRdf(const ir_node *n);
/**
 * construct fpaRdf node
 */
ir_node *new_bd_arm_fpaRdf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *op_mode);

extern ir_op *op_arm_Smull;
ir_op *get_op_arm_Smull(void);
int is_arm_Smull(const ir_node *n);
/**
 * construct Smull node
 */
ir_node *new_bd_arm_Smull(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_arm_Add;
ir_op *get_op_arm_Add(void);
int is_arm_Add(const ir_node *n);
/**
 * construct Add node
 */
ir_node *new_bd_arm_Add_imm(dbg_info *dbgi, ir_node *block, ir_node *left, unsigned char immediate_value, unsigned char immediate_rot);
/**
 * construct Add node
 */
ir_node *new_bd_arm_Add_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, arm_shift_modifier shift_modifier, unsigned shift_immediate);
/**
 * construct Add node
 */
ir_node *new_bd_arm_Add_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);
/**
 * construct Add node
 */
ir_node *new_bd_arm_Add_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, ir_node *shift, arm_shift_modifier shift_modifier);

extern ir_op *op_arm_fpaFix;
ir_op *get_op_arm_fpaFix(void);
int is_arm_fpaFix(const ir_node *n);
/**
 * construct fpaFix node
 */
ir_node *new_bd_arm_fpaFix(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_mode *mode);

extern ir_op *op_arm_fpaMvf;
ir_op *get_op_arm_fpaMvf(void);
int is_arm_fpaMvf(const ir_node *n);
/**
 * construct fpaMvf node
 */
ir_node *new_bd_arm_fpaMvf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_mode *mode);

extern ir_op *op_arm_fpaCnfeBra;
ir_op *get_op_arm_fpaCnfeBra(void);
int is_arm_fpaCnfeBra(const ir_node *n);
/**
 * construct fpaCnfeBra node
 */
ir_node *new_bd_arm_fpaCnfeBra(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, int proj_num);

extern ir_op *op_arm_Mvn;
ir_op *get_op_arm_Mvn(void);
int is_arm_Mvn(const ir_node *n);
/**
 * construct Mvn node
 */
ir_node *new_bd_arm_Mvn_imm(dbg_info *dbgi, ir_node *block, unsigned char immediate_value, unsigned char immediate_rot);
/**
 * construct Mvn node
 */
ir_node *new_bd_arm_Mvn_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *op0, arm_shift_modifier shift_modifier, unsigned shift_immediate);
/**
 * construct Mvn node
 */
ir_node *new_bd_arm_Mvn_reg(dbg_info *dbgi, ir_node *block, ir_node *op0);
/**
 * construct Mvn node
 */
ir_node *new_bd_arm_Mvn_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, arm_shift_modifier shift_modifier);

extern ir_op *op_arm_Abs;
ir_op *get_op_arm_Abs(void);
int is_arm_Abs(const ir_node *n);
/**
 * construct Abs node
 */
ir_node *new_bd_arm_Abs(dbg_info *dbgi, ir_node *block, ir_node *op0);

extern ir_op *op_arm_B;
ir_op *get_op_arm_B(void);
int is_arm_B(const ir_node *n);
/**
 * construct B node
 */
ir_node *new_bd_arm_B(dbg_info *dbgi, ir_node *block, ir_node *op0, int proj_num);

extern ir_op *op_arm_LoadStackM3Epilogue;
ir_op *get_op_arm_LoadStackM3Epilogue(void);
int is_arm_LoadStackM3Epilogue(const ir_node *n);
/**
 * construct LoadStackM3Epilogue node
 */
ir_node *new_bd_arm_LoadStackM3Epilogue(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_arm_Tst;
ir_op *get_op_arm_Tst(void);
int is_arm_Tst(const ir_node *n);
/**
 * construct Tst node
 */
ir_node *new_bd_arm_Tst_imm(dbg_info *dbgi, ir_node *block, ir_node *left, unsigned char immediate_value, unsigned char immediate_rot, bool ins_permuted, bool is_unsigned);
/**
 * construct Tst node
 */
ir_node *new_bd_arm_Tst_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, arm_shift_modifier shift_modifier, unsigned shift_immediate, bool ins_permuted, bool is_unsigned);
/**
 * construct Tst node
 */
ir_node *new_bd_arm_Tst_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, bool ins_permuted, bool is_unsigned);
/**
 * construct Tst node
 */
ir_node *new_bd_arm_Tst_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, ir_node *shift, arm_shift_modifier shift_modifier, bool ins_permuted, bool is_unsigned);

extern ir_op *op_arm_Umull;
ir_op *get_op_arm_Umull(void);
int is_arm_Umull(const ir_node *n);
/**
 * construct Umull node
 */
ir_node *new_bd_arm_Umull(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_arm_Bic;
ir_op *get_op_arm_Bic(void);
int is_arm_Bic(const ir_node *n);
/**
 * construct Bic node
 */
ir_node *new_bd_arm_Bic_imm(dbg_info *dbgi, ir_node *block, ir_node *left, unsigned char immediate_value, unsigned char immediate_rot);
/**
 * construct Bic node
 */
ir_node *new_bd_arm_Bic_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, arm_shift_modifier shift_modifier, unsigned shift_immediate);
/**
 * construct Bic node
 */
ir_node *new_bd_arm_Bic_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);
/**
 * construct Bic node
 */
ir_node *new_bd_arm_Bic_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, ir_node *shift, arm_shift_modifier shift_modifier);

extern ir_op *op_arm_Sub;
ir_op *get_op_arm_Sub(void);
int is_arm_Sub(const ir_node *n);
/**
 * construct Sub node
 */
ir_node *new_bd_arm_Sub_imm(dbg_info *dbgi, ir_node *block, ir_node *left, unsigned char immediate_value, unsigned char immediate_rot);
/**
 * construct Sub node
 */
ir_node *new_bd_arm_Sub_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, arm_shift_modifier shift_modifier, unsigned shift_immediate);
/**
 * construct Sub node
 */
ir_node *new_bd_arm_Sub_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);
/**
 * construct Sub node
 */
ir_node *new_bd_arm_Sub_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, ir_node *shift, arm_shift_modifier shift_modifier);

extern ir_op *op_arm_Mul;
ir_op *get_op_arm_Mul(void);
int is_arm_Mul(const ir_node *n);
/**
 * construct Mul node
 */
ir_node *new_bd_arm_Mul(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_arm_fpaRsf;
ir_op *get_op_arm_fpaRsf(void);
int is_arm_fpaRsf(const ir_node *n);
/**
 * construct fpaRsf node
 */
ir_node *new_bd_arm_fpaRsf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *mode);

extern ir_op *op_arm_fpaMnf;
ir_op *get_op_arm_fpaMnf(void);
int is_arm_fpaMnf(const ir_node *n);
/**
 * construct fpaMnf node
 */
ir_node *new_bd_arm_fpaMnf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_mode *mode);

extern ir_op *op_arm_fpaFml;
ir_op *get_op_arm_fpaFml(void);
int is_arm_fpaFml(const ir_node *n);
/**
 * construct fpaFml node
 */
ir_node *new_bd_arm_fpaFml(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *mode);

extern ir_op *op_arm_fpaSuf;
ir_op *get_op_arm_fpaSuf(void);
int is_arm_fpaSuf(const ir_node *n);
/**
 * construct fpaSuf node
 */
ir_node *new_bd_arm_fpaSuf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *mode);

extern ir_op *op_arm_fpaDbl2GP;
ir_op *get_op_arm_fpaDbl2GP(void);
int is_arm_fpaDbl2GP(const ir_node *n);
/**
 * construct fpaDbl2GP node
 */
ir_node *new_bd_arm_fpaDbl2GP(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_arm_CopyB;
ir_op *get_op_arm_CopyB(void);
int is_arm_CopyB(const ir_node *n);
/**
 * construct CopyB node
 */
ir_node *new_bd_arm_CopyB(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2, ir_node *op3, ir_node *op4, ir_node *op5, unsigned size);

extern ir_op *op_arm_AddSP;
ir_op *get_op_arm_AddSP(void);
int is_arm_AddSP(const ir_node *n);
/**
 * construct AddSP node
 */
ir_node *new_bd_arm_AddSP(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2);

extern ir_op *op_arm_fpaAdf;
ir_op *get_op_arm_fpaAdf(void);
int is_arm_fpaAdf(const ir_node *n);
/**
 * construct fpaAdf node
 */
ir_node *new_bd_arm_fpaAdf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *mode);

extern ir_op *op_arm_fpaCmfBra;
ir_op *get_op_arm_fpaCmfBra(void);
int is_arm_fpaCmfBra(const ir_node *n);
/**
 * construct fpaCmfBra node
 */
ir_node *new_bd_arm_fpaCmfBra(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, int proj_num);

extern ir_op *op_arm_fpaStf;
ir_op *get_op_arm_fpaStf(void);
int is_arm_fpaStf(const ir_node *n);
/**
 * construct fpaStf node
 */
ir_node *new_bd_arm_fpaStf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2, ir_mode *op_mode);

extern ir_op *op_arm_FrameAddr;
ir_op *get_op_arm_FrameAddr(void);
int is_arm_FrameAddr(const ir_node *n);
/**
 * construct FrameAddr node
 */
ir_node *new_bd_arm_FrameAddr(dbg_info *dbgi, ir_node *block, ir_node *base, ir_entity *entity);

extern ir_op *op_arm_And;
ir_op *get_op_arm_And(void);
int is_arm_And(const ir_node *n);
/**
 * construct And node
 */
ir_node *new_bd_arm_And_imm(dbg_info *dbgi, ir_node *block, ir_node *left, unsigned char immediate_value, unsigned char immediate_rot);
/**
 * construct And node
 */
ir_node *new_bd_arm_And_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, arm_shift_modifier shift_modifier, unsigned shift_immediate);
/**
 * construct And node
 */
ir_node *new_bd_arm_And_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);
/**
 * construct And node
 */
ir_node *new_bd_arm_And_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, ir_node *shift, arm_shift_modifier shift_modifier);

extern ir_op *op_arm_Str;
ir_op *get_op_arm_Str(void);
int is_arm_Str(const ir_node *n);
/**
 * construct Str node
 */
ir_node *new_bd_arm_Str(dbg_info *dbgi, ir_node *block, ir_node *ptr, ir_node *val, ir_node *mem, ir_mode *ls_mode, ir_entity *entity, int entity_sign, long offset, bool is_frame_entity);

extern ir_op *op_arm_fpaFlt;
ir_op *get_op_arm_fpaFlt(void);
int is_arm_fpaFlt(const ir_node *n);
/**
 * construct fpaFlt node
 */
ir_node *new_bd_arm_fpaFlt(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_mode *mode);

extern ir_op *op_arm_fpaDvf;
ir_op *get_op_arm_fpaDvf(void);
int is_arm_fpaDvf(const ir_node *n);
/**
 * construct fpaDvf node
 */
ir_node *new_bd_arm_fpaDvf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *op_mode);

extern ir_op *op_arm_SwitchJmp;
ir_op *get_op_arm_SwitchJmp(void);
int is_arm_SwitchJmp(const ir_node *n);
/**
 * construct SwitchJmp node
 */
ir_node *new_bd_arm_SwitchJmp(dbg_info *dbgi, ir_node *block, ir_node *op0, int n_projs, long def_proj_num);

extern ir_op *op_arm_StoreStackM4Inc;
ir_op *get_op_arm_StoreStackM4Inc(void);
int is_arm_StoreStackM4Inc(const ir_node *n);
/**
 * construct StoreStackM4Inc node
 */
ir_node *new_bd_arm_StoreStackM4Inc(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2, ir_node *op3, ir_node *op4, ir_node *op5);

extern ir_op *op_arm_SymConst;
ir_op *get_op_arm_SymConst(void);
int is_arm_SymConst(const ir_node *n);
/**
 * construct SymConst node
 */
ir_node *new_bd_arm_SymConst(dbg_info *dbgi, ir_node *block, ir_entity *entity);

extern ir_op *op_arm_fpaMuf;
ir_op *get_op_arm_fpaMuf(void);
int is_arm_fpaMuf(const ir_node *n);
/**
 * construct fpaMuf node
 */
ir_node *new_bd_arm_fpaMuf(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, ir_mode *mode);

extern ir_op *op_arm_Eor;
ir_op *get_op_arm_Eor(void);
int is_arm_Eor(const ir_node *n);
/**
 * construct Eor node
 */
ir_node *new_bd_arm_Eor_imm(dbg_info *dbgi, ir_node *block, ir_node *left, unsigned char immediate_value, unsigned char immediate_rot);
/**
 * construct Eor node
 */
ir_node *new_bd_arm_Eor_reg_shift_imm(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, arm_shift_modifier shift_modifier, unsigned shift_immediate);
/**
 * construct Eor node
 */
ir_node *new_bd_arm_Eor_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);
/**
 * construct Eor node
 */
ir_node *new_bd_arm_Eor_reg_shift_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, ir_node *shift, arm_shift_modifier shift_modifier);

extern ir_op *op_arm_fpaCmfeBra;
ir_op *get_op_arm_fpaCmfeBra(void);
int is_arm_fpaCmfeBra(const ir_node *n);
/**
 * construct fpaCmfeBra node
 */
ir_node *new_bd_arm_fpaCmfeBra(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, int proj_num);

extern ir_op *op_arm_fpaCnfBra;
ir_op *get_op_arm_fpaCnfBra(void);
int is_arm_fpaCnfBra(const ir_node *n);
/**
 * construct fpaCnfBra node
 */
ir_node *new_bd_arm_fpaCnfBra(dbg_info *dbgi, ir_node *block, ir_node *op0, ir_node *op1, int proj_num);

extern ir_op *op_arm_Jmp;
ir_op *get_op_arm_Jmp(void);
int is_arm_Jmp(const ir_node *n);
/**
 * construct Jmp node
 */
ir_node *new_bd_arm_Jmp(dbg_info *dbgi, ir_node *block);



enum pn_arm_Ldr {
	pn_arm_Ldr_res = 0,
	pn_arm_Ldr_M = 1,
};

enum n_arm_Ldr {
	n_arm_Ldr_ptr = 0,
	n_arm_Ldr_mem = 1,
};

enum pn_arm_fpaLdf {
	pn_arm_fpaLdf_res = 0,
	pn_arm_fpaLdf_M = 1,
};

enum pn_arm_fpaFrd {
	pn_arm_fpaFrd_res = 0,
	pn_arm_fpaFrd_M = 1,
};

enum pn_arm_fpaFdv {
	pn_arm_fpaFdv_res = 0,
	pn_arm_fpaFdv_M = 1,
};

enum pn_arm_SubSPandCopy {
	pn_arm_SubSPandCopy_stack = 0,
	pn_arm_SubSPandCopy_addr = 1,
	pn_arm_SubSPandCopy_M = 2,
};

enum n_arm_SubSPandCopy {
	n_arm_SubSPandCopy_stack = 0,
	n_arm_SubSPandCopy_size = 1,
	n_arm_SubSPandCopy_mem = 2,
};

enum pn_arm_fpaRdf {
	pn_arm_fpaRdf_res = 0,
	pn_arm_fpaRdf_M = 1,
};

enum pn_arm_Smull {
	pn_arm_Smull_low = 0,
	pn_arm_Smull_high = 1,
};

enum pn_arm_LoadStackM3Epilogue {
	pn_arm_LoadStackM3Epilogue_res0 = 0,
	pn_arm_LoadStackM3Epilogue_res1 = 1,
	pn_arm_LoadStackM3Epilogue_res2 = 2,
	pn_arm_LoadStackM3Epilogue_M = 3,
};

enum pn_arm_Umull {
	pn_arm_Umull_low = 0,
	pn_arm_Umull_high = 1,
};

enum pn_arm_fpaDbl2GP {
	pn_arm_fpaDbl2GP_low = 0,
	pn_arm_fpaDbl2GP_high = 1,
	pn_arm_fpaDbl2GP_M = 2,
};

enum pn_arm_CopyB {
	pn_arm_CopyB_M = 0,
};

enum pn_arm_AddSP {
	pn_arm_AddSP_stack = 0,
	pn_arm_AddSP_M = 1,
};

enum n_arm_FrameAddr {
	n_arm_FrameAddr_base = 0,
};

enum pn_arm_Str {
	pn_arm_Str_mem = 0,
};

enum n_arm_Str {
	n_arm_Str_ptr = 0,
	n_arm_Str_val = 1,
	n_arm_Str_mem = 2,
};

enum pn_arm_fpaDvf {
	pn_arm_fpaDvf_res = 0,
	pn_arm_fpaDvf_M = 1,
};

enum pn_arm_StoreStackM4Inc {
	pn_arm_StoreStackM4Inc_ptr = 0,
	pn_arm_StoreStackM4Inc_M = 1,
};


#endif
