/**
 * @file
 * @brief  The generated interface for the register allocator.
 *          Contains register classes and types and register constraints
 *          for all nodes where constraints were given in spec.
 * @note    DO NOT EDIT THIS FILE, your changes will be lost.
 *          Edit libfirm/ir/be/ia32/ia32_spec.pl instead.
 *          created by: libfirm/ir/be/scripts/generate_regalloc_if.pl libfirm/ir/be/ia32/ia32_spec.pl libfirm/ir/be/ia32
 * $date    Tue May  4 15:35:28 2010
 */
#include "config.h"

#include "gen_ia32_regalloc_if.h"
#include "gen_ia32_machine.h"
#include "bearch_ia32_t.h"
#include "irmode.h"

static const arch_register_req_t ia32_class_reg_req_xmm;
static const arch_register_req_t ia32_class_reg_req_flags;
static const arch_register_req_t ia32_class_reg_req_gp;
static const arch_register_req_t ia32_class_reg_req_st;
static const arch_register_req_t ia32_class_reg_req_mmx;
static const arch_register_req_t ia32_class_reg_req_fp_cw;
static const arch_register_req_t ia32_class_reg_req_vfp;

arch_register_class_t ia32_reg_classes[] = {
	{ 0, "ia32_xmm", N_ia32_xmm_REGS, NULL, ia32_xmm_regs, 0, &ia32_class_reg_req_xmm },
	{ 1, "ia32_flags", N_ia32_flags_REGS, NULL, ia32_flags_regs, arch_register_class_flag_manual_ra, &ia32_class_reg_req_flags },
	{ 2, "ia32_gp", N_ia32_gp_REGS, NULL, ia32_gp_regs, 0, &ia32_class_reg_req_gp },
	{ 3, "ia32_st", N_ia32_st_REGS, NULL, ia32_st_regs, arch_register_class_flag_manual_ra, &ia32_class_reg_req_st },
	{ 4, "ia32_mmx", N_ia32_mmx_REGS, NULL, ia32_mmx_regs, arch_register_class_flag_manual_ra, &ia32_class_reg_req_mmx },
	{ 5, "ia32_fp_cw", N_ia32_fp_cw_REGS, NULL, ia32_fp_cw_regs, arch_register_class_flag_manual_ra|arch_register_class_flag_state, &ia32_class_reg_req_fp_cw },
	{ 6, "ia32_vfp", N_ia32_vfp_REGS, NULL, ia32_vfp_regs, 0, &ia32_class_reg_req_vfp }
};

static const arch_register_req_t ia32_class_reg_req_xmm = {
	arch_register_req_type_normal,
	&ia32_reg_classes[CLASS_ia32_xmm],
	NULL,
	0,
	0
};
static const unsigned ia32_limited_xmm_xmm0 [] = { (1 << REG_XMM0) };
static const arch_register_req_t ia32_single_reg_req_xmm_xmm0 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_xmm],
	ia32_limited_xmm_xmm0,
	0,
	0
};
static const unsigned ia32_limited_xmm_xmm1 [] = { (1 << REG_XMM1) };
static const arch_register_req_t ia32_single_reg_req_xmm_xmm1 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_xmm],
	ia32_limited_xmm_xmm1,
	0,
	0
};
static const unsigned ia32_limited_xmm_xmm2 [] = { (1 << REG_XMM2) };
static const arch_register_req_t ia32_single_reg_req_xmm_xmm2 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_xmm],
	ia32_limited_xmm_xmm2,
	0,
	0
};
static const unsigned ia32_limited_xmm_xmm3 [] = { (1 << REG_XMM3) };
static const arch_register_req_t ia32_single_reg_req_xmm_xmm3 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_xmm],
	ia32_limited_xmm_xmm3,
	0,
	0
};
static const unsigned ia32_limited_xmm_xmm4 [] = { (1 << REG_XMM4) };
static const arch_register_req_t ia32_single_reg_req_xmm_xmm4 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_xmm],
	ia32_limited_xmm_xmm4,
	0,
	0
};
static const unsigned ia32_limited_xmm_xmm5 [] = { (1 << REG_XMM5) };
static const arch_register_req_t ia32_single_reg_req_xmm_xmm5 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_xmm],
	ia32_limited_xmm_xmm5,
	0,
	0
};
static const unsigned ia32_limited_xmm_xmm6 [] = { (1 << REG_XMM6) };
static const arch_register_req_t ia32_single_reg_req_xmm_xmm6 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_xmm],
	ia32_limited_xmm_xmm6,
	0,
	0
};
static const unsigned ia32_limited_xmm_xmm7 [] = { (1 << REG_XMM7) };
static const arch_register_req_t ia32_single_reg_req_xmm_xmm7 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_xmm],
	ia32_limited_xmm_xmm7,
	0,
	0
};
static const unsigned ia32_limited_xmm_xmm_NOREG [] = { (1 << REG_XMM_NOREG) };
static const arch_register_req_t ia32_single_reg_req_xmm_xmm_NOREG = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_xmm],
	ia32_limited_xmm_xmm_NOREG,
	0,
	0
};
static const arch_register_req_t ia32_class_reg_req_flags = {
	arch_register_req_type_normal,
	&ia32_reg_classes[CLASS_ia32_flags],
	NULL,
	0,
	0
};
static const unsigned ia32_limited_flags_eflags [] = { (1 << REG_EFLAGS) };
static const arch_register_req_t ia32_single_reg_req_flags_eflags = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_flags],
	ia32_limited_flags_eflags,
	0,
	0
};
static const arch_register_req_t ia32_class_reg_req_gp = {
	arch_register_req_type_normal,
	&ia32_reg_classes[CLASS_ia32_gp],
	NULL,
	0,
	0
};
static const unsigned ia32_limited_gp_edx [] = { (1 << REG_EDX) };
static const arch_register_req_t ia32_single_reg_req_gp_edx = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_gp],
	ia32_limited_gp_edx,
	0,
	0
};
static const unsigned ia32_limited_gp_ecx [] = { (1 << REG_ECX) };
static const arch_register_req_t ia32_single_reg_req_gp_ecx = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_gp],
	ia32_limited_gp_ecx,
	0,
	0
};
static const unsigned ia32_limited_gp_eax [] = { (1 << REG_EAX) };
static const arch_register_req_t ia32_single_reg_req_gp_eax = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_gp],
	ia32_limited_gp_eax,
	0,
	0
};
static const unsigned ia32_limited_gp_ebx [] = { (1 << REG_EBX) };
static const arch_register_req_t ia32_single_reg_req_gp_ebx = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_gp],
	ia32_limited_gp_ebx,
	0,
	0
};
static const unsigned ia32_limited_gp_esi [] = { (1 << REG_ESI) };
static const arch_register_req_t ia32_single_reg_req_gp_esi = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_gp],
	ia32_limited_gp_esi,
	0,
	0
};
static const unsigned ia32_limited_gp_edi [] = { (1 << REG_EDI) };
static const arch_register_req_t ia32_single_reg_req_gp_edi = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_gp],
	ia32_limited_gp_edi,
	0,
	0
};
static const unsigned ia32_limited_gp_ebp [] = { (1 << REG_EBP) };
static const arch_register_req_t ia32_single_reg_req_gp_ebp = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_gp],
	ia32_limited_gp_ebp,
	0,
	0
};
static const unsigned ia32_limited_gp_esp [] = { (1 << REG_ESP) };
static const arch_register_req_t ia32_single_reg_req_gp_esp = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_gp],
	ia32_limited_gp_esp,
	0,
	0
};
static const unsigned ia32_limited_gp_gp_NOREG [] = { (1 << REG_GP_NOREG) };
static const arch_register_req_t ia32_single_reg_req_gp_gp_NOREG = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_gp],
	ia32_limited_gp_gp_NOREG,
	0,
	0
};
static const arch_register_req_t ia32_class_reg_req_st = {
	arch_register_req_type_normal,
	&ia32_reg_classes[CLASS_ia32_st],
	NULL,
	0,
	0
};
static const unsigned ia32_limited_st_st0 [] = { (1 << REG_ST0) };
static const arch_register_req_t ia32_single_reg_req_st_st0 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_st],
	ia32_limited_st_st0,
	0,
	0
};
static const unsigned ia32_limited_st_st1 [] = { (1 << REG_ST1) };
static const arch_register_req_t ia32_single_reg_req_st_st1 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_st],
	ia32_limited_st_st1,
	0,
	0
};
static const unsigned ia32_limited_st_st2 [] = { (1 << REG_ST2) };
static const arch_register_req_t ia32_single_reg_req_st_st2 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_st],
	ia32_limited_st_st2,
	0,
	0
};
static const unsigned ia32_limited_st_st3 [] = { (1 << REG_ST3) };
static const arch_register_req_t ia32_single_reg_req_st_st3 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_st],
	ia32_limited_st_st3,
	0,
	0
};
static const unsigned ia32_limited_st_st4 [] = { (1 << REG_ST4) };
static const arch_register_req_t ia32_single_reg_req_st_st4 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_st],
	ia32_limited_st_st4,
	0,
	0
};
static const unsigned ia32_limited_st_st5 [] = { (1 << REG_ST5) };
static const arch_register_req_t ia32_single_reg_req_st_st5 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_st],
	ia32_limited_st_st5,
	0,
	0
};
static const unsigned ia32_limited_st_st6 [] = { (1 << REG_ST6) };
static const arch_register_req_t ia32_single_reg_req_st_st6 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_st],
	ia32_limited_st_st6,
	0,
	0
};
static const unsigned ia32_limited_st_st7 [] = { (1 << REG_ST7) };
static const arch_register_req_t ia32_single_reg_req_st_st7 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_st],
	ia32_limited_st_st7,
	0,
	0
};
static const arch_register_req_t ia32_class_reg_req_mmx = {
	arch_register_req_type_normal,
	&ia32_reg_classes[CLASS_ia32_mmx],
	NULL,
	0,
	0
};
static const unsigned ia32_limited_mmx_mm0 [] = { (1 << REG_MM0) };
static const arch_register_req_t ia32_single_reg_req_mmx_mm0 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_mmx],
	ia32_limited_mmx_mm0,
	0,
	0
};
static const unsigned ia32_limited_mmx_mm1 [] = { (1 << REG_MM1) };
static const arch_register_req_t ia32_single_reg_req_mmx_mm1 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_mmx],
	ia32_limited_mmx_mm1,
	0,
	0
};
static const unsigned ia32_limited_mmx_mm2 [] = { (1 << REG_MM2) };
static const arch_register_req_t ia32_single_reg_req_mmx_mm2 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_mmx],
	ia32_limited_mmx_mm2,
	0,
	0
};
static const unsigned ia32_limited_mmx_mm3 [] = { (1 << REG_MM3) };
static const arch_register_req_t ia32_single_reg_req_mmx_mm3 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_mmx],
	ia32_limited_mmx_mm3,
	0,
	0
};
static const unsigned ia32_limited_mmx_mm4 [] = { (1 << REG_MM4) };
static const arch_register_req_t ia32_single_reg_req_mmx_mm4 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_mmx],
	ia32_limited_mmx_mm4,
	0,
	0
};
static const unsigned ia32_limited_mmx_mm5 [] = { (1 << REG_MM5) };
static const arch_register_req_t ia32_single_reg_req_mmx_mm5 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_mmx],
	ia32_limited_mmx_mm5,
	0,
	0
};
static const unsigned ia32_limited_mmx_mm6 [] = { (1 << REG_MM6) };
static const arch_register_req_t ia32_single_reg_req_mmx_mm6 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_mmx],
	ia32_limited_mmx_mm6,
	0,
	0
};
static const unsigned ia32_limited_mmx_mm7 [] = { (1 << REG_MM7) };
static const arch_register_req_t ia32_single_reg_req_mmx_mm7 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_mmx],
	ia32_limited_mmx_mm7,
	0,
	0
};
static const arch_register_req_t ia32_class_reg_req_fp_cw = {
	arch_register_req_type_normal,
	&ia32_reg_classes[CLASS_ia32_fp_cw],
	NULL,
	0,
	0
};
static const unsigned ia32_limited_fp_cw_fpcw [] = { (1 << REG_FPCW) };
static const arch_register_req_t ia32_single_reg_req_fp_cw_fpcw = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_fp_cw],
	ia32_limited_fp_cw_fpcw,
	0,
	0
};
static const arch_register_req_t ia32_class_reg_req_vfp = {
	arch_register_req_type_normal,
	&ia32_reg_classes[CLASS_ia32_vfp],
	NULL,
	0,
	0
};
static const unsigned ia32_limited_vfp_vf0 [] = { (1 << REG_VF0) };
static const arch_register_req_t ia32_single_reg_req_vfp_vf0 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_vfp],
	ia32_limited_vfp_vf0,
	0,
	0
};
static const unsigned ia32_limited_vfp_vf1 [] = { (1 << REG_VF1) };
static const arch_register_req_t ia32_single_reg_req_vfp_vf1 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_vfp],
	ia32_limited_vfp_vf1,
	0,
	0
};
static const unsigned ia32_limited_vfp_vf2 [] = { (1 << REG_VF2) };
static const arch_register_req_t ia32_single_reg_req_vfp_vf2 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_vfp],
	ia32_limited_vfp_vf2,
	0,
	0
};
static const unsigned ia32_limited_vfp_vf3 [] = { (1 << REG_VF3) };
static const arch_register_req_t ia32_single_reg_req_vfp_vf3 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_vfp],
	ia32_limited_vfp_vf3,
	0,
	0
};
static const unsigned ia32_limited_vfp_vf4 [] = { (1 << REG_VF4) };
static const arch_register_req_t ia32_single_reg_req_vfp_vf4 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_vfp],
	ia32_limited_vfp_vf4,
	0,
	0
};
static const unsigned ia32_limited_vfp_vf5 [] = { (1 << REG_VF5) };
static const arch_register_req_t ia32_single_reg_req_vfp_vf5 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_vfp],
	ia32_limited_vfp_vf5,
	0,
	0
};
static const unsigned ia32_limited_vfp_vf6 [] = { (1 << REG_VF6) };
static const arch_register_req_t ia32_single_reg_req_vfp_vf6 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_vfp],
	ia32_limited_vfp_vf6,
	0,
	0
};
static const unsigned ia32_limited_vfp_vf7 [] = { (1 << REG_VF7) };
static const arch_register_req_t ia32_single_reg_req_vfp_vf7 = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_vfp],
	ia32_limited_vfp_vf7,
	0,
	0
};
static const unsigned ia32_limited_vfp_vfp_NOREG [] = { (1 << REG_VFP_NOREG) };
static const arch_register_req_t ia32_single_reg_req_vfp_vfp_NOREG = {
	arch_register_req_type_limited,
	&ia32_reg_classes[CLASS_ia32_vfp],
	ia32_limited_vfp_vfp_NOREG,
	0,
	0
};

const arch_register_t ia32_xmm_regs[N_ia32_xmm_REGS] = {
	{
		"xmm0",
		&ia32_reg_classes[CLASS_ia32_xmm],
		REG_XMM0,
		arch_register_type_caller_save,
		&ia32_single_reg_req_xmm_xmm0
	},
	{
		"xmm1",
		&ia32_reg_classes[CLASS_ia32_xmm],
		REG_XMM1,
		arch_register_type_caller_save,
		&ia32_single_reg_req_xmm_xmm1
	},
	{
		"xmm2",
		&ia32_reg_classes[CLASS_ia32_xmm],
		REG_XMM2,
		arch_register_type_caller_save,
		&ia32_single_reg_req_xmm_xmm2
	},
	{
		"xmm3",
		&ia32_reg_classes[CLASS_ia32_xmm],
		REG_XMM3,
		arch_register_type_caller_save,
		&ia32_single_reg_req_xmm_xmm3
	},
	{
		"xmm4",
		&ia32_reg_classes[CLASS_ia32_xmm],
		REG_XMM4,
		arch_register_type_caller_save,
		&ia32_single_reg_req_xmm_xmm4
	},
	{
		"xmm5",
		&ia32_reg_classes[CLASS_ia32_xmm],
		REG_XMM5,
		arch_register_type_caller_save,
		&ia32_single_reg_req_xmm_xmm5
	},
	{
		"xmm6",
		&ia32_reg_classes[CLASS_ia32_xmm],
		REG_XMM6,
		arch_register_type_caller_save,
		&ia32_single_reg_req_xmm_xmm6
	},
	{
		"xmm7",
		&ia32_reg_classes[CLASS_ia32_xmm],
		REG_XMM7,
		arch_register_type_caller_save,
		&ia32_single_reg_req_xmm_xmm7
	},
	{
		"xmm_NOREG",
		&ia32_reg_classes[CLASS_ia32_xmm],
		REG_XMM_NOREG,
		arch_register_type_ignore | arch_register_type_virtual,
		&ia32_single_reg_req_xmm_xmm_NOREG
	},
};
const arch_register_t ia32_flags_regs[N_ia32_flags_REGS] = {
	{
		"eflags",
		&ia32_reg_classes[CLASS_ia32_flags],
		REG_EFLAGS,
		arch_register_type_none,
		&ia32_single_reg_req_flags_eflags
	},
};
const arch_register_t ia32_gp_regs[N_ia32_gp_REGS] = {
	{
		"edx",
		&ia32_reg_classes[CLASS_ia32_gp],
		REG_EDX,
		arch_register_type_caller_save,
		&ia32_single_reg_req_gp_edx
	},
	{
		"ecx",
		&ia32_reg_classes[CLASS_ia32_gp],
		REG_ECX,
		arch_register_type_caller_save,
		&ia32_single_reg_req_gp_ecx
	},
	{
		"eax",
		&ia32_reg_classes[CLASS_ia32_gp],
		REG_EAX,
		arch_register_type_caller_save,
		&ia32_single_reg_req_gp_eax
	},
	{
		"ebx",
		&ia32_reg_classes[CLASS_ia32_gp],
		REG_EBX,
		arch_register_type_callee_save,
		&ia32_single_reg_req_gp_ebx
	},
	{
		"esi",
		&ia32_reg_classes[CLASS_ia32_gp],
		REG_ESI,
		arch_register_type_callee_save,
		&ia32_single_reg_req_gp_esi
	},
	{
		"edi",
		&ia32_reg_classes[CLASS_ia32_gp],
		REG_EDI,
		arch_register_type_callee_save,
		&ia32_single_reg_req_gp_edi
	},
	{
		"ebp",
		&ia32_reg_classes[CLASS_ia32_gp],
		REG_EBP,
		arch_register_type_callee_save,
		&ia32_single_reg_req_gp_ebp
	},
	{
		"esp",
		&ia32_reg_classes[CLASS_ia32_gp],
		REG_ESP,
		arch_register_type_ignore,
		&ia32_single_reg_req_gp_esp
	},
	{
		"gp_NOREG",
		&ia32_reg_classes[CLASS_ia32_gp],
		REG_GP_NOREG,
		arch_register_type_ignore | arch_register_type_joker | arch_register_type_virtual,
		&ia32_single_reg_req_gp_gp_NOREG
	},
};
const arch_register_t ia32_st_regs[N_ia32_st_REGS] = {
	{
		"st",
		&ia32_reg_classes[CLASS_ia32_st],
		REG_ST0,
		arch_register_type_ignore,
		&ia32_single_reg_req_st_st0
	},
	{
		"st(1)",
		&ia32_reg_classes[CLASS_ia32_st],
		REG_ST1,
		arch_register_type_ignore,
		&ia32_single_reg_req_st_st1
	},
	{
		"st(2)",
		&ia32_reg_classes[CLASS_ia32_st],
		REG_ST2,
		arch_register_type_ignore,
		&ia32_single_reg_req_st_st2
	},
	{
		"st(3)",
		&ia32_reg_classes[CLASS_ia32_st],
		REG_ST3,
		arch_register_type_ignore,
		&ia32_single_reg_req_st_st3
	},
	{
		"st(4)",
		&ia32_reg_classes[CLASS_ia32_st],
		REG_ST4,
		arch_register_type_ignore,
		&ia32_single_reg_req_st_st4
	},
	{
		"st(5)",
		&ia32_reg_classes[CLASS_ia32_st],
		REG_ST5,
		arch_register_type_ignore,
		&ia32_single_reg_req_st_st5
	},
	{
		"st(6)",
		&ia32_reg_classes[CLASS_ia32_st],
		REG_ST6,
		arch_register_type_ignore,
		&ia32_single_reg_req_st_st6
	},
	{
		"st(7)",
		&ia32_reg_classes[CLASS_ia32_st],
		REG_ST7,
		arch_register_type_ignore,
		&ia32_single_reg_req_st_st7
	},
};
const arch_register_t ia32_mmx_regs[N_ia32_mmx_REGS] = {
	{
		"mm0",
		&ia32_reg_classes[CLASS_ia32_mmx],
		REG_MM0,
		arch_register_type_ignore,
		&ia32_single_reg_req_mmx_mm0
	},
	{
		"mm1",
		&ia32_reg_classes[CLASS_ia32_mmx],
		REG_MM1,
		arch_register_type_ignore,
		&ia32_single_reg_req_mmx_mm1
	},
	{
		"mm2",
		&ia32_reg_classes[CLASS_ia32_mmx],
		REG_MM2,
		arch_register_type_ignore,
		&ia32_single_reg_req_mmx_mm2
	},
	{
		"mm3",
		&ia32_reg_classes[CLASS_ia32_mmx],
		REG_MM3,
		arch_register_type_ignore,
		&ia32_single_reg_req_mmx_mm3
	},
	{
		"mm4",
		&ia32_reg_classes[CLASS_ia32_mmx],
		REG_MM4,
		arch_register_type_ignore,
		&ia32_single_reg_req_mmx_mm4
	},
	{
		"mm5",
		&ia32_reg_classes[CLASS_ia32_mmx],
		REG_MM5,
		arch_register_type_ignore,
		&ia32_single_reg_req_mmx_mm5
	},
	{
		"mm6",
		&ia32_reg_classes[CLASS_ia32_mmx],
		REG_MM6,
		arch_register_type_ignore,
		&ia32_single_reg_req_mmx_mm6
	},
	{
		"mm7",
		&ia32_reg_classes[CLASS_ia32_mmx],
		REG_MM7,
		arch_register_type_ignore,
		&ia32_single_reg_req_mmx_mm7
	},
};
const arch_register_t ia32_fp_cw_regs[N_ia32_fp_cw_REGS] = {
	{
		"fpcw",
		&ia32_reg_classes[CLASS_ia32_fp_cw],
		REG_FPCW,
		arch_register_type_ignore | arch_register_type_state,
		&ia32_single_reg_req_fp_cw_fpcw
	},
};
const arch_register_t ia32_vfp_regs[N_ia32_vfp_REGS] = {
	{
		"vf0",
		&ia32_reg_classes[CLASS_ia32_vfp],
		REG_VF0,
		arch_register_type_caller_save,
		&ia32_single_reg_req_vfp_vf0
	},
	{
		"vf1",
		&ia32_reg_classes[CLASS_ia32_vfp],
		REG_VF1,
		arch_register_type_caller_save,
		&ia32_single_reg_req_vfp_vf1
	},
	{
		"vf2",
		&ia32_reg_classes[CLASS_ia32_vfp],
		REG_VF2,
		arch_register_type_caller_save,
		&ia32_single_reg_req_vfp_vf2
	},
	{
		"vf3",
		&ia32_reg_classes[CLASS_ia32_vfp],
		REG_VF3,
		arch_register_type_caller_save,
		&ia32_single_reg_req_vfp_vf3
	},
	{
		"vf4",
		&ia32_reg_classes[CLASS_ia32_vfp],
		REG_VF4,
		arch_register_type_caller_save,
		&ia32_single_reg_req_vfp_vf4
	},
	{
		"vf5",
		&ia32_reg_classes[CLASS_ia32_vfp],
		REG_VF5,
		arch_register_type_caller_save,
		&ia32_single_reg_req_vfp_vf5
	},
	{
		"vf6",
		&ia32_reg_classes[CLASS_ia32_vfp],
		REG_VF6,
		arch_register_type_caller_save,
		&ia32_single_reg_req_vfp_vf6
	},
	{
		"vf7",
		&ia32_reg_classes[CLASS_ia32_vfp],
		REG_VF7,
		arch_register_type_caller_save,
		&ia32_single_reg_req_vfp_vf7
	},
	{
		"vfp_NOREG",
		&ia32_reg_classes[CLASS_ia32_vfp],
		REG_VFP_NOREG,
		arch_register_type_ignore | arch_register_type_joker | arch_register_type_virtual,
		&ia32_single_reg_req_vfp_vfp_NOREG
	},
};


void ia32_register_init(void)
{
	ia32_reg_classes[CLASS_ia32_xmm].mode = mode_E;
	ia32_reg_classes[CLASS_ia32_flags].mode = mode_Iu;
	ia32_reg_classes[CLASS_ia32_gp].mode = mode_Iu;
	ia32_reg_classes[CLASS_ia32_st].mode = mode_E;
	ia32_reg_classes[CLASS_ia32_mmx].mode = mode_E;
	ia32_reg_classes[CLASS_ia32_fp_cw].mode = mode_fpcw;
	ia32_reg_classes[CLASS_ia32_vfp].mode = mode_E;

}
