/**
 * @file
 * @brief  The generated interface for the register allocator.
 *          Contains register classes and types and register constraints
 *          for all nodes where constraints were given in spec.
 * @note    DO NOT EDIT THIS FILE, your changes will be lost.
 *          Edit libfirm/ir/be/mips/mips_spec.pl instead.
 *          created by: libfirm/ir/be/scripts/generate_regalloc_if.pl libfirm/ir/be/mips/mips_spec.pl libfirm/ir/be/mips
 * $date    Tue May  4 15:35:33 2010
 */
#include "config.h"

#include "gen_mips_regalloc_if.h"
#include "gen_mips_machine.h"
#include "bearch_mips_t.h"
#include "irmode.h"

static const arch_register_req_t mips_class_reg_req_gp;

arch_register_class_t mips_reg_classes[] = {
	{ 0, "mips_gp", N_mips_gp_REGS, NULL, mips_gp_regs, 0, &mips_class_reg_req_gp }
};

static const arch_register_req_t mips_class_reg_req_gp = {
	arch_register_req_type_normal,
	&mips_reg_classes[CLASS_mips_gp],
	NULL,
	0,
	0
};
static const unsigned mips_limited_gp_zero [] = { (1 << REG_ZERO), 0 };
static const arch_register_req_t mips_single_reg_req_gp_zero = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_zero,
	0,
	0
};
static const unsigned mips_limited_gp_at [] = { (1 << REG_AT), 0 };
static const arch_register_req_t mips_single_reg_req_gp_at = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_at,
	0,
	0
};
static const unsigned mips_limited_gp_v0 [] = { (1 << REG_V0), 0 };
static const arch_register_req_t mips_single_reg_req_gp_v0 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_v0,
	0,
	0
};
static const unsigned mips_limited_gp_v1 [] = { (1 << REG_V1), 0 };
static const arch_register_req_t mips_single_reg_req_gp_v1 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_v1,
	0,
	0
};
static const unsigned mips_limited_gp_a0 [] = { (1 << REG_A0), 0 };
static const arch_register_req_t mips_single_reg_req_gp_a0 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_a0,
	0,
	0
};
static const unsigned mips_limited_gp_a1 [] = { (1 << REG_A1), 0 };
static const arch_register_req_t mips_single_reg_req_gp_a1 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_a1,
	0,
	0
};
static const unsigned mips_limited_gp_a2 [] = { (1 << REG_A2), 0 };
static const arch_register_req_t mips_single_reg_req_gp_a2 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_a2,
	0,
	0
};
static const unsigned mips_limited_gp_a3 [] = { (1 << REG_A3), 0 };
static const arch_register_req_t mips_single_reg_req_gp_a3 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_a3,
	0,
	0
};
static const unsigned mips_limited_gp_t0 [] = { (1 << REG_T0), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t0 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t0,
	0,
	0
};
static const unsigned mips_limited_gp_t1 [] = { (1 << REG_T1), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t1 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t1,
	0,
	0
};
static const unsigned mips_limited_gp_t2 [] = { (1 << REG_T2), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t2 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t2,
	0,
	0
};
static const unsigned mips_limited_gp_t3 [] = { (1 << REG_T3), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t3 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t3,
	0,
	0
};
static const unsigned mips_limited_gp_t4 [] = { (1 << REG_T4), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t4 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t4,
	0,
	0
};
static const unsigned mips_limited_gp_t5 [] = { (1 << REG_T5), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t5 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t5,
	0,
	0
};
static const unsigned mips_limited_gp_t6 [] = { (1 << REG_T6), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t6 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t6,
	0,
	0
};
static const unsigned mips_limited_gp_t7 [] = { (1 << REG_T7), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t7 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t7,
	0,
	0
};
static const unsigned mips_limited_gp_s0 [] = { (1 << REG_S0), 0 };
static const arch_register_req_t mips_single_reg_req_gp_s0 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_s0,
	0,
	0
};
static const unsigned mips_limited_gp_s1 [] = { (1 << REG_S1), 0 };
static const arch_register_req_t mips_single_reg_req_gp_s1 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_s1,
	0,
	0
};
static const unsigned mips_limited_gp_s2 [] = { (1 << REG_S2), 0 };
static const arch_register_req_t mips_single_reg_req_gp_s2 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_s2,
	0,
	0
};
static const unsigned mips_limited_gp_s3 [] = { (1 << REG_S3), 0 };
static const arch_register_req_t mips_single_reg_req_gp_s3 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_s3,
	0,
	0
};
static const unsigned mips_limited_gp_s4 [] = { (1 << REG_S4), 0 };
static const arch_register_req_t mips_single_reg_req_gp_s4 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_s4,
	0,
	0
};
static const unsigned mips_limited_gp_s5 [] = { (1 << REG_S5), 0 };
static const arch_register_req_t mips_single_reg_req_gp_s5 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_s5,
	0,
	0
};
static const unsigned mips_limited_gp_s6 [] = { (1 << REG_S6), 0 };
static const arch_register_req_t mips_single_reg_req_gp_s6 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_s6,
	0,
	0
};
static const unsigned mips_limited_gp_s7 [] = { (1 << REG_S7), 0 };
static const arch_register_req_t mips_single_reg_req_gp_s7 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_s7,
	0,
	0
};
static const unsigned mips_limited_gp_t8 [] = { (1 << REG_T8), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t8 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t8,
	0,
	0
};
static const unsigned mips_limited_gp_t9 [] = { (1 << REG_T9), 0 };
static const arch_register_req_t mips_single_reg_req_gp_t9 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_t9,
	0,
	0
};
static const unsigned mips_limited_gp_kt0 [] = { (1 << REG_KT0), 0 };
static const arch_register_req_t mips_single_reg_req_gp_kt0 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_kt0,
	0,
	0
};
static const unsigned mips_limited_gp_kt1 [] = { (1 << REG_KT1), 0 };
static const arch_register_req_t mips_single_reg_req_gp_kt1 = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_kt1,
	0,
	0
};
static const unsigned mips_limited_gp_gp [] = { (1 << REG_GP), 0 };
static const arch_register_req_t mips_single_reg_req_gp_gp = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_gp,
	0,
	0
};
static const unsigned mips_limited_gp_sp [] = { (1 << REG_SP), 0 };
static const arch_register_req_t mips_single_reg_req_gp_sp = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_sp,
	0,
	0
};
static const unsigned mips_limited_gp_fp [] = { (1 << REG_FP), 0 };
static const arch_register_req_t mips_single_reg_req_gp_fp = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_fp,
	0,
	0
};
static const unsigned mips_limited_gp_ra [] = { (1 << REG_RA), 0 };
static const arch_register_req_t mips_single_reg_req_gp_ra = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_ra,
	0,
	0
};
static const unsigned mips_limited_gp_gp_NOREG [] = { 0, (1 << (REG_GP_NOREG % 32)) };
static const arch_register_req_t mips_single_reg_req_gp_gp_NOREG = {
	arch_register_req_type_limited,
	&mips_reg_classes[CLASS_mips_gp],
	mips_limited_gp_gp_NOREG,
	0,
	0
};

const arch_register_t mips_gp_regs[N_mips_gp_REGS] = {
	{
		"zero",
		&mips_reg_classes[CLASS_mips_gp],
		REG_ZERO,
		arch_register_type_ignore,
		&mips_single_reg_req_gp_zero
	},
	{
		"at",
		&mips_reg_classes[CLASS_mips_gp],
		REG_AT,
		arch_register_type_ignore,
		&mips_single_reg_req_gp_at
	},
	{
		"2",
		&mips_reg_classes[CLASS_mips_gp],
		REG_V0,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_v0
	},
	{
		"3",
		&mips_reg_classes[CLASS_mips_gp],
		REG_V1,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_v1
	},
	{
		"4",
		&mips_reg_classes[CLASS_mips_gp],
		REG_A0,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_a0
	},
	{
		"5",
		&mips_reg_classes[CLASS_mips_gp],
		REG_A1,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_a1
	},
	{
		"6",
		&mips_reg_classes[CLASS_mips_gp],
		REG_A2,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_a2
	},
	{
		"7",
		&mips_reg_classes[CLASS_mips_gp],
		REG_A3,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_a3
	},
	{
		"8",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T0,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t0
	},
	{
		"9",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T1,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t1
	},
	{
		"10",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T2,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t2
	},
	{
		"11",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T3,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t3
	},
	{
		"12",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T4,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t4
	},
	{
		"13",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T5,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t5
	},
	{
		"14",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T6,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t6
	},
	{
		"15",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T7,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t7
	},
	{
		"16",
		&mips_reg_classes[CLASS_mips_gp],
		REG_S0,
		arch_register_type_callee_save,
		&mips_single_reg_req_gp_s0
	},
	{
		"17",
		&mips_reg_classes[CLASS_mips_gp],
		REG_S1,
		arch_register_type_callee_save,
		&mips_single_reg_req_gp_s1
	},
	{
		"18",
		&mips_reg_classes[CLASS_mips_gp],
		REG_S2,
		arch_register_type_callee_save,
		&mips_single_reg_req_gp_s2
	},
	{
		"19",
		&mips_reg_classes[CLASS_mips_gp],
		REG_S3,
		arch_register_type_callee_save,
		&mips_single_reg_req_gp_s3
	},
	{
		"20",
		&mips_reg_classes[CLASS_mips_gp],
		REG_S4,
		arch_register_type_callee_save,
		&mips_single_reg_req_gp_s4
	},
	{
		"21",
		&mips_reg_classes[CLASS_mips_gp],
		REG_S5,
		arch_register_type_callee_save,
		&mips_single_reg_req_gp_s5
	},
	{
		"22",
		&mips_reg_classes[CLASS_mips_gp],
		REG_S6,
		arch_register_type_callee_save,
		&mips_single_reg_req_gp_s6
	},
	{
		"23",
		&mips_reg_classes[CLASS_mips_gp],
		REG_S7,
		arch_register_type_callee_save,
		&mips_single_reg_req_gp_s7
	},
	{
		"24",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T8,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t8
	},
	{
		"25",
		&mips_reg_classes[CLASS_mips_gp],
		REG_T9,
		arch_register_type_caller_save,
		&mips_single_reg_req_gp_t9
	},
	{
		"kt0",
		&mips_reg_classes[CLASS_mips_gp],
		REG_KT0,
		arch_register_type_ignore,
		&mips_single_reg_req_gp_kt0
	},
	{
		"kt1",
		&mips_reg_classes[CLASS_mips_gp],
		REG_KT1,
		arch_register_type_ignore,
		&mips_single_reg_req_gp_kt1
	},
	{
		"gp",
		&mips_reg_classes[CLASS_mips_gp],
		REG_GP,
		arch_register_type_ignore,
		&mips_single_reg_req_gp_gp
	},
	{
		"sp",
		&mips_reg_classes[CLASS_mips_gp],
		REG_SP,
		arch_register_type_ignore,
		&mips_single_reg_req_gp_sp
	},
	{
		"fp",
		&mips_reg_classes[CLASS_mips_gp],
		REG_FP,
		arch_register_type_ignore,
		&mips_single_reg_req_gp_fp
	},
	{
		"ra",
		&mips_reg_classes[CLASS_mips_gp],
		REG_RA,
		arch_register_type_caller_save | arch_register_type_callee_save,
		&mips_single_reg_req_gp_ra
	},
	{
		"!NOREG_INVALID!",
		&mips_reg_classes[CLASS_mips_gp],
		REG_GP_NOREG,
		arch_register_type_ignore | arch_register_type_joker | arch_register_type_virtual,
		&mips_single_reg_req_gp_gp_NOREG
	},
};


void mips_register_init(void)
{
	mips_reg_classes[CLASS_mips_gp].mode = mode_Iu;

}
