/**
 * @file
 * @brief  The generated interface for the register allocator.
 *          Contains register classes and types and register constraints
 *          for all nodes where constraints were given in spec.
 * @note    DO NOT EDIT THIS FILE, your changes will be lost.
 *          Edit libfirm/ir/be/ppc32/ppc32_spec.pl instead.
 *          created by: libfirm/ir/be/scripts/generate_regalloc_if.pl libfirm/ir/be/ppc32/ppc32_spec.pl libfirm/ir/be/ppc32
 * $date    Tue May  4 15:35:36 2010
 */
#include "config.h"

#include "gen_ppc32_regalloc_if.h"
#include "gen_ppc32_machine.h"
#include "bearch_ppc32_t.h"
#include "irmode.h"

static const arch_register_req_t ppc32_class_reg_req_link;
static const arch_register_req_t ppc32_class_reg_req_count;
static const arch_register_req_t ppc32_class_reg_req_gp;
static const arch_register_req_t ppc32_class_reg_req_fp;
static const arch_register_req_t ppc32_class_reg_req_condition;

arch_register_class_t ppc32_reg_classes[] = {
	{ 0, "ppc32_link", N_ppc32_link_REGS, NULL, ppc32_link_regs, 0, &ppc32_class_reg_req_link },
	{ 1, "ppc32_count", N_ppc32_count_REGS, NULL, ppc32_count_regs, 0, &ppc32_class_reg_req_count },
	{ 2, "ppc32_gp", N_ppc32_gp_REGS, NULL, ppc32_gp_regs, 0, &ppc32_class_reg_req_gp },
	{ 3, "ppc32_fp", N_ppc32_fp_REGS, NULL, ppc32_fp_regs, 0, &ppc32_class_reg_req_fp },
	{ 4, "ppc32_condition", N_ppc32_condition_REGS, NULL, ppc32_condition_regs, 0, &ppc32_class_reg_req_condition }
};

static const arch_register_req_t ppc32_class_reg_req_link = {
	arch_register_req_type_normal,
	&ppc32_reg_classes[CLASS_ppc32_link],
	NULL,
	0,
	0
};
static const unsigned ppc32_limited_link_lr [] = { (1 << REG_LR) };
static const arch_register_req_t ppc32_single_reg_req_link_lr = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_link],
	ppc32_limited_link_lr,
	0,
	0
};
static const arch_register_req_t ppc32_class_reg_req_count = {
	arch_register_req_type_normal,
	&ppc32_reg_classes[CLASS_ppc32_count],
	NULL,
	0,
	0
};
static const unsigned ppc32_limited_count_ctr [] = { (1 << REG_CTR) };
static const arch_register_req_t ppc32_single_reg_req_count_ctr = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_count],
	ppc32_limited_count_ctr,
	0,
	0
};
static const arch_register_req_t ppc32_class_reg_req_gp = {
	arch_register_req_type_normal,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	NULL,
	0,
	0
};
static const unsigned ppc32_limited_gp_r0 [] = { (1 << REG_R0) };
static const arch_register_req_t ppc32_single_reg_req_gp_r0 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r0,
	0,
	0
};
static const unsigned ppc32_limited_gp_r2 [] = { (1 << REG_R2) };
static const arch_register_req_t ppc32_single_reg_req_gp_r2 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r2,
	0,
	0
};
static const unsigned ppc32_limited_gp_r3 [] = { (1 << REG_R3) };
static const arch_register_req_t ppc32_single_reg_req_gp_r3 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r3,
	0,
	0
};
static const unsigned ppc32_limited_gp_r4 [] = { (1 << REG_R4) };
static const arch_register_req_t ppc32_single_reg_req_gp_r4 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r4,
	0,
	0
};
static const unsigned ppc32_limited_gp_r5 [] = { (1 << REG_R5) };
static const arch_register_req_t ppc32_single_reg_req_gp_r5 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r5,
	0,
	0
};
static const unsigned ppc32_limited_gp_r6 [] = { (1 << REG_R6) };
static const arch_register_req_t ppc32_single_reg_req_gp_r6 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r6,
	0,
	0
};
static const unsigned ppc32_limited_gp_r7 [] = { (1 << REG_R7) };
static const arch_register_req_t ppc32_single_reg_req_gp_r7 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r7,
	0,
	0
};
static const unsigned ppc32_limited_gp_r8 [] = { (1 << REG_R8) };
static const arch_register_req_t ppc32_single_reg_req_gp_r8 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r8,
	0,
	0
};
static const unsigned ppc32_limited_gp_r9 [] = { (1 << REG_R9) };
static const arch_register_req_t ppc32_single_reg_req_gp_r9 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r9,
	0,
	0
};
static const unsigned ppc32_limited_gp_r10 [] = { (1 << REG_R10) };
static const arch_register_req_t ppc32_single_reg_req_gp_r10 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r10,
	0,
	0
};
static const unsigned ppc32_limited_gp_r13 [] = { (1 << REG_R13) };
static const arch_register_req_t ppc32_single_reg_req_gp_r13 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r13,
	0,
	0
};
static const unsigned ppc32_limited_gp_r14 [] = { (1 << REG_R14) };
static const arch_register_req_t ppc32_single_reg_req_gp_r14 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r14,
	0,
	0
};
static const unsigned ppc32_limited_gp_r15 [] = { (1 << REG_R15) };
static const arch_register_req_t ppc32_single_reg_req_gp_r15 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r15,
	0,
	0
};
static const unsigned ppc32_limited_gp_r31 [] = { (1 << REG_R31) };
static const arch_register_req_t ppc32_single_reg_req_gp_r31 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r31,
	0,
	0
};
static const unsigned ppc32_limited_gp_r1 [] = { (1 << REG_R1) };
static const arch_register_req_t ppc32_single_reg_req_gp_r1 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_gp],
	ppc32_limited_gp_r1,
	0,
	0
};
static const arch_register_req_t ppc32_class_reg_req_fp = {
	arch_register_req_type_normal,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	NULL,
	0,
	0
};
static const unsigned ppc32_limited_fp_f1 [] = { (1 << REG_F1) };
static const arch_register_req_t ppc32_single_reg_req_fp_f1 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f1,
	0,
	0
};
static const unsigned ppc32_limited_fp_f2 [] = { (1 << REG_F2) };
static const arch_register_req_t ppc32_single_reg_req_fp_f2 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f2,
	0,
	0
};
static const unsigned ppc32_limited_fp_f3 [] = { (1 << REG_F3) };
static const arch_register_req_t ppc32_single_reg_req_fp_f3 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f3,
	0,
	0
};
static const unsigned ppc32_limited_fp_f4 [] = { (1 << REG_F4) };
static const arch_register_req_t ppc32_single_reg_req_fp_f4 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f4,
	0,
	0
};
static const unsigned ppc32_limited_fp_f5 [] = { (1 << REG_F5) };
static const arch_register_req_t ppc32_single_reg_req_fp_f5 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f5,
	0,
	0
};
static const unsigned ppc32_limited_fp_f6 [] = { (1 << REG_F6) };
static const arch_register_req_t ppc32_single_reg_req_fp_f6 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f6,
	0,
	0
};
static const unsigned ppc32_limited_fp_f7 [] = { (1 << REG_F7) };
static const arch_register_req_t ppc32_single_reg_req_fp_f7 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f7,
	0,
	0
};
static const unsigned ppc32_limited_fp_f8 [] = { (1 << REG_F8) };
static const arch_register_req_t ppc32_single_reg_req_fp_f8 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f8,
	0,
	0
};
static const unsigned ppc32_limited_fp_f9 [] = { (1 << REG_F9) };
static const arch_register_req_t ppc32_single_reg_req_fp_f9 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f9,
	0,
	0
};
static const unsigned ppc32_limited_fp_f10 [] = { (1 << REG_F10) };
static const arch_register_req_t ppc32_single_reg_req_fp_f10 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f10,
	0,
	0
};
static const unsigned ppc32_limited_fp_f11 [] = { (1 << REG_F11) };
static const arch_register_req_t ppc32_single_reg_req_fp_f11 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f11,
	0,
	0
};
static const unsigned ppc32_limited_fp_f12 [] = { (1 << REG_F12) };
static const arch_register_req_t ppc32_single_reg_req_fp_f12 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f12,
	0,
	0
};
static const unsigned ppc32_limited_fp_f13 [] = { (1 << REG_F13) };
static const arch_register_req_t ppc32_single_reg_req_fp_f13 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f13,
	0,
	0
};
static const unsigned ppc32_limited_fp_f14 [] = { (1 << REG_F14) };
static const arch_register_req_t ppc32_single_reg_req_fp_f14 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f14,
	0,
	0
};
static const unsigned ppc32_limited_fp_f15 [] = { (1 << REG_F15) };
static const arch_register_req_t ppc32_single_reg_req_fp_f15 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f15,
	0,
	0
};
static const unsigned ppc32_limited_fp_f16 [] = { (1 << REG_F16) };
static const arch_register_req_t ppc32_single_reg_req_fp_f16 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_fp],
	ppc32_limited_fp_f16,
	0,
	0
};
static const arch_register_req_t ppc32_class_reg_req_condition = {
	arch_register_req_type_normal,
	&ppc32_reg_classes[CLASS_ppc32_condition],
	NULL,
	0,
	0
};
static const unsigned ppc32_limited_condition_cr0 [] = { (1 << REG_CR0) };
static const arch_register_req_t ppc32_single_reg_req_condition_cr0 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_condition],
	ppc32_limited_condition_cr0,
	0,
	0
};
static const unsigned ppc32_limited_condition_cr1 [] = { (1 << REG_CR1) };
static const arch_register_req_t ppc32_single_reg_req_condition_cr1 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_condition],
	ppc32_limited_condition_cr1,
	0,
	0
};
static const unsigned ppc32_limited_condition_cr2 [] = { (1 << REG_CR2) };
static const arch_register_req_t ppc32_single_reg_req_condition_cr2 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_condition],
	ppc32_limited_condition_cr2,
	0,
	0
};
static const unsigned ppc32_limited_condition_cr3 [] = { (1 << REG_CR3) };
static const arch_register_req_t ppc32_single_reg_req_condition_cr3 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_condition],
	ppc32_limited_condition_cr3,
	0,
	0
};
static const unsigned ppc32_limited_condition_cr4 [] = { (1 << REG_CR4) };
static const arch_register_req_t ppc32_single_reg_req_condition_cr4 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_condition],
	ppc32_limited_condition_cr4,
	0,
	0
};
static const unsigned ppc32_limited_condition_cr5 [] = { (1 << REG_CR5) };
static const arch_register_req_t ppc32_single_reg_req_condition_cr5 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_condition],
	ppc32_limited_condition_cr5,
	0,
	0
};
static const unsigned ppc32_limited_condition_cr6 [] = { (1 << REG_CR6) };
static const arch_register_req_t ppc32_single_reg_req_condition_cr6 = {
	arch_register_req_type_limited,
	&ppc32_reg_classes[CLASS_ppc32_condition],
	ppc32_limited_condition_cr6,
	0,
	0
};

const arch_register_t ppc32_link_regs[N_ppc32_link_REGS] = {
	{
		"lr",
		&ppc32_reg_classes[CLASS_ppc32_link],
		REG_LR,
		arch_register_type_ignore,
		&ppc32_single_reg_req_link_lr
	},
};
const arch_register_t ppc32_count_regs[N_ppc32_count_REGS] = {
	{
		"ctr",
		&ppc32_reg_classes[CLASS_ppc32_count],
		REG_CTR,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_count_ctr
	},
};
const arch_register_t ppc32_gp_regs[N_ppc32_gp_REGS] = {
	{
		"r0",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R0,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r0
	},
	{
		"r2",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R2,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r2
	},
	{
		"r3",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R3,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r3
	},
	{
		"r4",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R4,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r4
	},
	{
		"r5",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R5,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r5
	},
	{
		"r6",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R6,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r6
	},
	{
		"r7",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R7,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r7
	},
	{
		"r8",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R8,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r8
	},
	{
		"r9",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R9,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r9
	},
	{
		"r10",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R10,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_gp_r10
	},
	{
		"r13",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R13,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_gp_r13
	},
	{
		"r14",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R14,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_gp_r14
	},
	{
		"r15",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R15,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_gp_r15
	},
	{
		"r31",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R31,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_gp_r31
	},
	{
		"r1",
		&ppc32_reg_classes[CLASS_ppc32_gp],
		REG_R1,
		arch_register_type_callee_save | arch_register_type_ignore,
		&ppc32_single_reg_req_gp_r1
	},
};
const arch_register_t ppc32_fp_regs[N_ppc32_fp_REGS] = {
	{
		"f1",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F1,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f1
	},
	{
		"f2",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F2,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f2
	},
	{
		"f3",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F3,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f3
	},
	{
		"f4",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F4,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f4
	},
	{
		"f5",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F5,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f5
	},
	{
		"f6",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F6,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f6
	},
	{
		"f7",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F7,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f7
	},
	{
		"f8",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F8,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f8
	},
	{
		"f9",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F9,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f9
	},
	{
		"f10",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F10,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f10
	},
	{
		"f11",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F11,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f11
	},
	{
		"f12",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F12,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f12
	},
	{
		"f13",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F13,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_fp_f13
	},
	{
		"f14",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F14,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_fp_f14
	},
	{
		"f15",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F15,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_fp_f15
	},
	{
		"f16",
		&ppc32_reg_classes[CLASS_ppc32_fp],
		REG_F16,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_fp_f16
	},
};
const arch_register_t ppc32_condition_regs[N_ppc32_condition_REGS] = {
	{
		"cr0",
		&ppc32_reg_classes[CLASS_ppc32_condition],
		REG_CR0,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_condition_cr0
	},
	{
		"cr1",
		&ppc32_reg_classes[CLASS_ppc32_condition],
		REG_CR1,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_condition_cr1
	},
	{
		"cr2",
		&ppc32_reg_classes[CLASS_ppc32_condition],
		REG_CR2,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_condition_cr2
	},
	{
		"cr3",
		&ppc32_reg_classes[CLASS_ppc32_condition],
		REG_CR3,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_condition_cr3
	},
	{
		"cr4",
		&ppc32_reg_classes[CLASS_ppc32_condition],
		REG_CR4,
		arch_register_type_callee_save,
		&ppc32_single_reg_req_condition_cr4
	},
	{
		"cr5",
		&ppc32_reg_classes[CLASS_ppc32_condition],
		REG_CR5,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_condition_cr5
	},
	{
		"cr6",
		&ppc32_reg_classes[CLASS_ppc32_condition],
		REG_CR6,
		arch_register_type_caller_save,
		&ppc32_single_reg_req_condition_cr6
	},
};


void ppc32_register_init(void)
{
	ppc32_reg_classes[CLASS_ppc32_link].mode = mode_P;
	ppc32_reg_classes[CLASS_ppc32_count].mode = mode_P;
	ppc32_reg_classes[CLASS_ppc32_gp].mode = mode_P;
	ppc32_reg_classes[CLASS_ppc32_fp].mode = mode_D;
	ppc32_reg_classes[CLASS_ppc32_condition].mode = mode_P;

}
