/**
 * @file
 * @brief     Generated functions to emit code for assembler ir nodes.
 * @note      DO NOT EDIT THIS FILE, your changes will be lost.
 *            Edit libfirm/ir/be/sparc/sparc_spec.pl instead.
 *            created by: libfirm/ir/be/scripts/generate_emitter.pl libfirm/ir/be/sparc/sparc_spec.pl libfirm/ir/be/sparc
 * @date      Tue May  4 15:35:32 2010
 */
#include "config.h"

#include <stdio.h>

#include "irnode.h"
#include "irop_t.h"
#include "irprog_t.h"

#include "gen_sparc_emitter.h"
#include "sparc_new_nodes.h"
#include "sparc_emitter.h"

static void emit_sparc_ShiftRA(const ir_node *node) {
	be_emit_cstring("\tsra ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_LoadHi(const ir_node *node) {
	be_emit_cstring("\tsethi %hi(");
	sparc_emit_source_register(node, 0);
	be_emit_cstring("), ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Mov(const ir_node *node) {
	be_emit_cstring("\tmov ");
	sparc_emit_reg_or_imm(node, 0);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Xor(const ir_node *node) {
	be_emit_cstring("\txor ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Or(const ir_node *node) {
	be_emit_cstring("\tor ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Cmp(const ir_node *node) {
	be_emit_cstring("\tcmp ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_LoadLo(const ir_node *node) {
	be_emit_cstring("\tor ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", %lo(");
	sparc_emit_source_register(node, 1);
	be_emit_cstring("), ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Not(const ir_node *node) {
	be_emit_cstring("\txnor ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", %g0, ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_AddSP(const ir_node *node) {
	be_emit_cstring("\tsub ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_source_register(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Add(const ir_node *node) {
	be_emit_cstring("\tadd ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_SubSP(const ir_node *node) {
	be_emit_cstring("\tadd ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_source_register(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Store(const ir_node *node) {
	be_emit_cstring("\tst");
	sparc_emit_store_mode(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 1);
	be_emit_cstring(", [");
	sparc_emit_source_register(node, 0);
	sparc_emit_offset(node);
	be_emit_char(']');
	be_emit_finish_line_gas(node);
}

static void emit_sparc_And(const ir_node *node) {
	be_emit_cstring("\tand ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_UDiv(const ir_node *node) {
	be_emit_cstring("\tudiv ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_ShiftLL(const ir_node *node) {
	be_emit_cstring("\tsll ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Tst(const ir_node *node) {
	be_emit_cstring("\ttst ");
	sparc_emit_source_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_UMul(const ir_node *node) {
	be_emit_cstring("\tumul ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Minus(const ir_node *node) {
	be_emit_cstring("\tsub %g0, ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_ShiftLR(const ir_node *node) {
	be_emit_cstring("\tslr ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Load(const ir_node *node) {
	be_emit_cstring("\tld");
	sparc_emit_load_mode(node);
	be_emit_cstring(" [");
	sparc_emit_source_register(node, 0);
	sparc_emit_offset(node);
	be_emit_cstring("], ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Sub(const ir_node *node) {
	be_emit_cstring("\tsub ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

/**
 * Enters the emitter functions for handled nodes into the generic
 * pointer of an opcode.
 */
void sparc_register_spec_emitters(void) {

#define BE_EMIT(a) op_sparc_##a->ops.generic = (op_func)emit_sparc_##a

  /* generated emitter functions */
  BE_EMIT(ShiftRA);
  BE_EMIT(LoadHi);
  BE_EMIT(Mov);
  BE_EMIT(Xor);
  BE_EMIT(Or);
  BE_EMIT(Cmp);
  BE_EMIT(LoadLo);
  BE_EMIT(Not);
  BE_EMIT(AddSP);
  BE_EMIT(Add);
  BE_EMIT(SubSP);
  BE_EMIT(Store);
  BE_EMIT(And);
  BE_EMIT(UDiv);
  BE_EMIT(ShiftLL);
  BE_EMIT(Tst);
  BE_EMIT(UMul);
  BE_EMIT(Minus);
  BE_EMIT(ShiftLR);
  BE_EMIT(Load);
  BE_EMIT(Sub);

#undef BE_EMIT
}

