/**
 * @file
 * @brief Function prototypes for the new opcode functions.
 * @note  DO NOT EDIT THIS FILE, your changes will be lost.
 *        Edit libfirm/ir/be/sparc/sparc_spec.pl instead.
 *        created by: libfirm/ir/be/scripts/generate_new_opcodes.pl libfirm/ir/be/sparc/sparc_spec.pl libfirm/ir/be/sparc
 * @date  Tue May  4 15:35:32 2010
 */
#ifndef FIRM_BE_SPARC_GEN_SPARC_NEW_NODES_H
#define FIRM_BE_SPARC_GEN_SPARC_NEW_NODES_H

typedef enum _sparc_opcodes {
	iro_sparc_ShiftRA,
	iro_sparc_LoadHi,
	iro_sparc_Mov,
	iro_sparc_Xor,
	iro_sparc_Or,
	iro_sparc_HiImm,
	iro_sparc_Cmp,
	iro_sparc_LoadLo,
	iro_sparc_Not,
	iro_sparc_AddSP,
	iro_sparc_Add,
	iro_sparc_SubSP,
	iro_sparc_Store,
	iro_sparc_FrameAddr,
	iro_sparc_And,
	iro_sparc_Branch,
	iro_sparc_UDiv,
	iro_sparc_LoImm,
	iro_sparc_ShiftLL,
	iro_sparc_Tst,
	iro_sparc_UMul,
	iro_sparc_SwitchJmp,
	iro_sparc_Minus,
	iro_sparc_SymConst,
	iro_sparc_ShiftLR,
	iro_sparc_Save,
	iro_sparc_Load,
	iro_sparc_Sub,
	iro_sparc_Jmp,
	iro_sparc_last_generated,
	iro_sparc_last = iro_sparc_last_generated
} sparc_opcodes;

int is_sparc_irn(const ir_node *node);
int is_sparc_op(const ir_op *op);

int get_sparc_opcode_first(void);
int get_sparc_opcode_last(void);
int get_sparc_irn_opcode(const ir_node *node);
void sparc_create_opcodes(const arch_irn_ops_t *be_ops);
extern ir_op *op_sparc_ShiftRA;
ir_op *get_op_sparc_ShiftRA(void);
int is_sparc_ShiftRA(const ir_node *n);
/**
 * construct ShiftRA node
 */
ir_node *new_bd_sparc_ShiftRA_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct ShiftRA node
 */
ir_node *new_bd_sparc_ShiftRA_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_LoadHi;
ir_op *get_op_sparc_LoadHi(void);
int is_sparc_LoadHi(const ir_node *n);
/**
 * construct LoadHi: Load(ptr, mem) = sethi hi(ptr) -> reg
 */
ir_node *new_bd_sparc_LoadHi(dbg_info *dbgi, ir_node *block, ir_node *ptr, ir_node *mem, ir_mode *ls_mode, ir_entity *entity, int entity_sign, long offset, bool is_frame_entity);

extern ir_op *op_sparc_Mov;
ir_op *get_op_sparc_Mov(void);
int is_sparc_Mov(const ir_node *n);
/**
 * construct Mov node
 */
ir_node *new_bd_sparc_Mov_imm(dbg_info *dbgi, ir_node *block, int immediate_value);
/**
 * construct Mov node
 */
ir_node *new_bd_sparc_Mov_reg(dbg_info *dbgi, ir_node *block, ir_node *op0);

extern ir_op *op_sparc_Xor;
ir_op *get_op_sparc_Xor(void);
int is_sparc_Xor(const ir_node *n);
/**
 * construct Xor node
 */
ir_node *new_bd_sparc_Xor_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct Xor node
 */
ir_node *new_bd_sparc_Xor_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_Or;
ir_op *get_op_sparc_Or(void);
int is_sparc_Or(const ir_node *n);
/**
 * construct Or node
 */
ir_node *new_bd_sparc_Or_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct Or node
 */
ir_node *new_bd_sparc_Or_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_HiImm;
ir_op *get_op_sparc_HiImm(void);
int is_sparc_HiImm(const ir_node *n);
/**
 * construct LoadHi: Load(imm, mem) = sethi hi(imm) -> reg
 */
ir_node *new_bd_sparc_HiImm(dbg_info *dbgi, ir_node *block, int immediate_value);

extern ir_op *op_sparc_Cmp;
ir_op *get_op_sparc_Cmp(void);
int is_sparc_Cmp(const ir_node *n);
/**
 * construct Cmp node
 */
ir_node *new_bd_sparc_Cmp_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value, bool ins_permuted, bool is_unsigned);
/**
 * construct Cmp node
 */
ir_node *new_bd_sparc_Cmp_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right, bool ins_permuted, bool is_unsigned);

extern ir_op *op_sparc_LoadLo;
ir_op *get_op_sparc_LoadLo(void);
int is_sparc_LoadLo(const ir_node *n);
/**
 * construct LoadLo: Or(in, ptr, mem) = or in lo(ptr) -> reg
 */
ir_node *new_bd_sparc_LoadLo(dbg_info *dbgi, ir_node *block, ir_node *hireg, ir_node *ptr, ir_node *mem, ir_mode *ls_mode, ir_entity *entity, int entity_sign, long offset, bool is_frame_entity);

extern ir_op *op_sparc_Not;
ir_op *get_op_sparc_Not(void);
int is_sparc_Not(const ir_node *n);
/**
 * construct Not: Not(a) = !a
 */
ir_node *new_bd_sparc_Not(dbg_info *dbgi, ir_node *block, ir_node *op0);

extern ir_op *op_sparc_AddSP;
ir_op *get_op_sparc_AddSP(void);
int is_sparc_AddSP(const ir_node *n);
/**
 * alloc stack space
 */
ir_node *new_bd_sparc_AddSP(dbg_info *dbgi, ir_node *block, ir_node *stack, ir_node *size, ir_node *mem);

extern ir_op *op_sparc_Add;
ir_op *get_op_sparc_Add(void);
int is_sparc_Add(const ir_node *n);
/**
 * construct Add node
 */
ir_node *new_bd_sparc_Add_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct Add node
 */
ir_node *new_bd_sparc_Add_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_SubSP;
ir_op *get_op_sparc_SubSP(void);
int is_sparc_SubSP(const ir_node *n);
/**
 * free stack space
 */
ir_node *new_bd_sparc_SubSP(dbg_info *dbgi, ir_node *block, ir_node *stack, ir_node *size, ir_node *mem);

extern ir_op *op_sparc_Store;
ir_op *get_op_sparc_Store(void);
int is_sparc_Store(const ir_node *n);
/**
 * construct Store: Store(ptr, val, mem) = ST ptr,val
 */
ir_node *new_bd_sparc_Store(dbg_info *dbgi, ir_node *block, ir_node *ptr, ir_node *val, ir_node *mem, ir_mode *ls_mode, ir_entity *entity, int entity_sign, long offset, bool is_frame_entity);

extern ir_op *op_sparc_FrameAddr;
ir_op *get_op_sparc_FrameAddr(void);
int is_sparc_FrameAddr(const ir_node *n);
/**
 * construct FrameAddr node
 */
ir_node *new_bd_sparc_FrameAddr(dbg_info *dbgi, ir_node *block, ir_node *base, ir_entity *entity);

extern ir_op *op_sparc_And;
ir_op *get_op_sparc_And(void);
int is_sparc_And(const ir_node *n);
/**
 * construct And node
 */
ir_node *new_bd_sparc_And_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct And node
 */
ir_node *new_bd_sparc_And_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_Branch;
ir_op *get_op_sparc_Branch(void);
int is_sparc_Branch(const ir_node *n);
/**
 * construct Branch node
 */
ir_node *new_bd_sparc_Branch(dbg_info *dbgi, ir_node *block, ir_node *op0, int proj_num);

extern ir_op *op_sparc_UDiv;
ir_op *get_op_sparc_UDiv(void);
int is_sparc_UDiv(const ir_node *n);
/**
 * construct UDiv node
 */
ir_node *new_bd_sparc_UDiv_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct UDiv node
 */
ir_node *new_bd_sparc_UDiv_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_LoImm;
ir_op *get_op_sparc_LoImm(void);
int is_sparc_LoImm(const ir_node *n);
/**
 * construct LoadHi: Load(imm, mem) = sethi hi(imm) -> reg
 */
ir_node *new_bd_sparc_LoImm(dbg_info *dbgi, ir_node *block, ir_node *hireg, int immediate_value);

extern ir_op *op_sparc_ShiftLL;
ir_op *get_op_sparc_ShiftLL(void);
int is_sparc_ShiftLL(const ir_node *n);
/**
 * construct ShiftLL node
 */
ir_node *new_bd_sparc_ShiftLL_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct ShiftLL node
 */
ir_node *new_bd_sparc_ShiftLL_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_Tst;
ir_op *get_op_sparc_Tst(void);
int is_sparc_Tst(const ir_node *n);
/**
 * construct Tst node
 */
ir_node *new_bd_sparc_Tst(dbg_info *dbgi, ir_node *block, ir_node *left, bool ins_permuted, bool is_unsigned);

extern ir_op *op_sparc_UMul;
ir_op *get_op_sparc_UMul(void);
int is_sparc_UMul(const ir_node *n);
/**
 * construct UMul node
 */
ir_node *new_bd_sparc_UMul_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct UMul node
 */
ir_node *new_bd_sparc_UMul_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_SwitchJmp;
ir_op *get_op_sparc_SwitchJmp(void);
int is_sparc_SwitchJmp(const ir_node *n);
/**
 * construct SwitchJmp node
 */
ir_node *new_bd_sparc_SwitchJmp(dbg_info *dbgi, ir_node *block, ir_node *op0, int n_projs, long def_proj_num);

extern ir_op *op_sparc_Minus;
ir_op *get_op_sparc_Minus(void);
int is_sparc_Minus(const ir_node *n);
/**
 * construct Minus: Minus(a) = -a
 */
ir_node *new_bd_sparc_Minus(dbg_info *dbgi, ir_node *block, ir_node *op0);

extern ir_op *op_sparc_SymConst;
ir_op *get_op_sparc_SymConst(void);
int is_sparc_SymConst(const ir_node *n);
/**
 * construct SymConst node
 */
ir_node *new_bd_sparc_SymConst(dbg_info *dbgi, ir_node *block, ir_entity *entity);

extern ir_op *op_sparc_ShiftLR;
ir_op *get_op_sparc_ShiftLR(void);
int is_sparc_ShiftLR(const ir_node *n);
/**
 * construct ShiftLR node
 */
ir_node *new_bd_sparc_ShiftLR_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct ShiftLR node
 */
ir_node *new_bd_sparc_ShiftLR_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_Save;
ir_op *get_op_sparc_Save(void);
int is_sparc_Save(const ir_node *n);
/**
 * function prolog instruction. autom. saves sp & shifts the register window. previous out regs become the new in regs
 */
ir_node *new_bd_sparc_Save(dbg_info *dbgi, ir_node *block, ir_node *stack, ir_node *mem, int initial_stacksize);

extern ir_op *op_sparc_Load;
ir_op *get_op_sparc_Load(void);
int is_sparc_Load(const ir_node *n);
/**
 * construct Load: Load(ptr, mem) = LD ptr -> reg
 */
ir_node *new_bd_sparc_Load(dbg_info *dbgi, ir_node *block, ir_node *ptr, ir_node *mem, ir_mode *ls_mode, ir_entity *entity, int entity_sign, long offset, bool is_frame_entity);

extern ir_op *op_sparc_Sub;
ir_op *get_op_sparc_Sub(void);
int is_sparc_Sub(const ir_node *n);
/**
 * construct Sub node
 */
ir_node *new_bd_sparc_Sub_imm(dbg_info *dbgi, ir_node *block, ir_node *left, int immediate_value);
/**
 * construct Sub node
 */
ir_node *new_bd_sparc_Sub_reg(dbg_info *dbgi, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_sparc_Jmp;
ir_op *get_op_sparc_Jmp(void);
int is_sparc_Jmp(const ir_node *n);
/**
 * construct Jmp node
 */
ir_node *new_bd_sparc_Jmp(dbg_info *dbgi, ir_node *block);



enum pn_sparc_LoadHi {
	pn_sparc_LoadHi_res = 0,
	pn_sparc_LoadHi_M = 1,
};

enum n_sparc_LoadHi {
	n_sparc_LoadHi_ptr = 0,
	n_sparc_LoadHi_mem = 1,
};

enum pn_sparc_HiImm {
	pn_sparc_HiImm_res = 0,
};

enum pn_sparc_LoadLo {
	pn_sparc_LoadLo_res = 0,
	pn_sparc_LoadLo_M = 1,
};

enum n_sparc_LoadLo {
	n_sparc_LoadLo_hireg = 0,
	n_sparc_LoadLo_ptr = 1,
	n_sparc_LoadLo_mem = 2,
};

enum pn_sparc_AddSP {
	pn_sparc_AddSP_stack = 0,
	pn_sparc_AddSP_addr = 1,
	pn_sparc_AddSP_M = 2,
};

enum n_sparc_AddSP {
	n_sparc_AddSP_stack = 0,
	n_sparc_AddSP_size = 1,
	n_sparc_AddSP_mem = 2,
};

enum pn_sparc_SubSP {
	pn_sparc_SubSP_stack = 0,
	pn_sparc_SubSP_M = 1,
};

enum n_sparc_SubSP {
	n_sparc_SubSP_stack = 0,
	n_sparc_SubSP_size = 1,
	n_sparc_SubSP_mem = 2,
};

enum pn_sparc_Store {
	pn_sparc_Store_mem = 0,
};

enum n_sparc_Store {
	n_sparc_Store_ptr = 0,
	n_sparc_Store_val = 1,
	n_sparc_Store_mem = 2,
};

enum n_sparc_FrameAddr {
	n_sparc_FrameAddr_base = 0,
};

enum pn_sparc_UDiv {
	pn_sparc_UDiv_res = 0,
};

enum pn_sparc_LoImm {
	pn_sparc_LoImm_res = 0,
};

enum n_sparc_LoImm {
	n_sparc_LoImm_hireg = 0,
};

enum n_sparc_Tst {
	n_sparc_Tst_left = 0,
};

enum pn_sparc_UMul {
	pn_sparc_UMul_low = 0,
	pn_sparc_UMul_high = 1,
};

enum pn_sparc_Save {
	pn_sparc_Save_stack = 0,
	pn_sparc_Save_mem = 1,
};

enum n_sparc_Save {
	n_sparc_Save_stack = 0,
	n_sparc_Save_mem = 1,
};

enum pn_sparc_Load {
	pn_sparc_Load_res = 0,
	pn_sparc_Load_M = 1,
};

enum n_sparc_Load {
	n_sparc_Load_ptr = 0,
	n_sparc_Load_mem = 1,
};


#endif
