/**
 * @file
 * @brief  The generated interface for the register allocator.
 *          Contains register classes and types and register constraints
 *          for all nodes where constraints were given in spec.
 * @note    DO NOT EDIT THIS FILE, your changes will be lost.
 *          Edit libfirm/ir/be/sparc/sparc_spec.pl instead.
 *          created by: libfirm/ir/be/scripts/generate_regalloc_if.pl libfirm/ir/be/sparc/sparc_spec.pl libfirm/ir/be/sparc
 * $date    Tue May  4 15:35:32 2010
 */
#include "config.h"

#include "gen_sparc_regalloc_if.h"
#include "gen_sparc_machine.h"
#include "bearch_sparc_t.h"
#include "irmode.h"

static const arch_register_req_t sparc_class_reg_req_flags;
static const arch_register_req_t sparc_class_reg_req_gp;
static const arch_register_req_t sparc_class_reg_req_fp;

arch_register_class_t sparc_reg_classes[] = {
	{ 0, "sparc_flags", N_sparc_flags_REGS, NULL, sparc_flags_regs, arch_register_class_flag_manual_ra, &sparc_class_reg_req_flags },
	{ 1, "sparc_gp", N_sparc_gp_REGS, NULL, sparc_gp_regs, 0, &sparc_class_reg_req_gp },
	{ 2, "sparc_fp", N_sparc_fp_REGS, NULL, sparc_fp_regs, 0, &sparc_class_reg_req_fp }
};

static const arch_register_req_t sparc_class_reg_req_flags = {
	arch_register_req_type_normal,
	&sparc_reg_classes[CLASS_sparc_flags],
	NULL,
	0,
	0
};
static const unsigned sparc_limited_flags_y [] = { (1 << REG_Y) };
static const arch_register_req_t sparc_single_reg_req_flags_y = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_flags],
	sparc_limited_flags_y,
	0,
	0
};
static const arch_register_req_t sparc_class_reg_req_gp = {
	arch_register_req_type_normal,
	&sparc_reg_classes[CLASS_sparc_gp],
	NULL,
	0,
	0
};
static const unsigned sparc_limited_gp_g0 [] = { (1 << REG_G0), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_g0 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_g0,
	0,
	0
};
static const unsigned sparc_limited_gp_g1 [] = { (1 << REG_G1), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_g1 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_g1,
	0,
	0
};
static const unsigned sparc_limited_gp_g2 [] = { (1 << REG_G2), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_g2 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_g2,
	0,
	0
};
static const unsigned sparc_limited_gp_g3 [] = { (1 << REG_G3), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_g3 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_g3,
	0,
	0
};
static const unsigned sparc_limited_gp_g4 [] = { (1 << REG_G4), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_g4 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_g4,
	0,
	0
};
static const unsigned sparc_limited_gp_g5 [] = { (1 << REG_G5), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_g5 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_g5,
	0,
	0
};
static const unsigned sparc_limited_gp_g6 [] = { (1 << REG_G6), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_g6 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_g6,
	0,
	0
};
static const unsigned sparc_limited_gp_g7 [] = { (1 << REG_G7), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_g7 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_g7,
	0,
	0
};
static const unsigned sparc_limited_gp_o0 [] = { (1 << REG_O0), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_o0 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_o0,
	0,
	0
};
static const unsigned sparc_limited_gp_o1 [] = { (1 << REG_O1), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_o1 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_o1,
	0,
	0
};
static const unsigned sparc_limited_gp_o2 [] = { (1 << REG_O2), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_o2 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_o2,
	0,
	0
};
static const unsigned sparc_limited_gp_o3 [] = { (1 << REG_O3), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_o3 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_o3,
	0,
	0
};
static const unsigned sparc_limited_gp_o4 [] = { (1 << REG_O4), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_o4 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_o4,
	0,
	0
};
static const unsigned sparc_limited_gp_o5 [] = { (1 << REG_O5), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_o5 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_o5,
	0,
	0
};
static const unsigned sparc_limited_gp_sp [] = { (1 << REG_SP), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_sp = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_sp,
	0,
	0
};
static const unsigned sparc_limited_gp_o7 [] = { (1 << REG_O7), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_o7 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_o7,
	0,
	0
};
static const unsigned sparc_limited_gp_l0 [] = { (1 << REG_L0), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_l0 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_l0,
	0,
	0
};
static const unsigned sparc_limited_gp_l1 [] = { (1 << REG_L1), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_l1 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_l1,
	0,
	0
};
static const unsigned sparc_limited_gp_l2 [] = { (1 << REG_L2), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_l2 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_l2,
	0,
	0
};
static const unsigned sparc_limited_gp_l3 [] = { (1 << REG_L3), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_l3 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_l3,
	0,
	0
};
static const unsigned sparc_limited_gp_l4 [] = { (1 << REG_L4), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_l4 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_l4,
	0,
	0
};
static const unsigned sparc_limited_gp_l5 [] = { (1 << REG_L5), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_l5 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_l5,
	0,
	0
};
static const unsigned sparc_limited_gp_l6 [] = { (1 << REG_L6), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_l6 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_l6,
	0,
	0
};
static const unsigned sparc_limited_gp_l7 [] = { (1 << REG_L7), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_l7 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_l7,
	0,
	0
};
static const unsigned sparc_limited_gp_i0 [] = { (1 << REG_I0), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_i0 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_i0,
	0,
	0
};
static const unsigned sparc_limited_gp_i1 [] = { (1 << REG_I1), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_i1 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_i1,
	0,
	0
};
static const unsigned sparc_limited_gp_i2 [] = { (1 << REG_I2), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_i2 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_i2,
	0,
	0
};
static const unsigned sparc_limited_gp_i3 [] = { (1 << REG_I3), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_i3 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_i3,
	0,
	0
};
static const unsigned sparc_limited_gp_i4 [] = { (1 << REG_I4), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_i4 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_i4,
	0,
	0
};
static const unsigned sparc_limited_gp_i5 [] = { (1 << REG_I5), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_i5 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_i5,
	0,
	0
};
static const unsigned sparc_limited_gp_fp [] = { (1 << REG_FP), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_fp = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_fp,
	0,
	0
};
static const unsigned sparc_limited_gp_i7 [] = { (1 << REG_I7), 0 };
static const arch_register_req_t sparc_single_reg_req_gp_i7 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_gp],
	sparc_limited_gp_i7,
	0,
	0
};
static const arch_register_req_t sparc_class_reg_req_fp = {
	arch_register_req_type_normal,
	&sparc_reg_classes[CLASS_sparc_fp],
	NULL,
	0,
	0
};
static const unsigned sparc_limited_fp_f0 [] = { (1 << REG_F0), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f0 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f0,
	0,
	0
};
static const unsigned sparc_limited_fp_f1 [] = { (1 << REG_F1), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f1 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f1,
	0,
	0
};
static const unsigned sparc_limited_fp_f2 [] = { (1 << REG_F2), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f2 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f2,
	0,
	0
};
static const unsigned sparc_limited_fp_f3 [] = { (1 << REG_F3), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f3 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f3,
	0,
	0
};
static const unsigned sparc_limited_fp_f4 [] = { (1 << REG_F4), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f4 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f4,
	0,
	0
};
static const unsigned sparc_limited_fp_f5 [] = { (1 << REG_F5), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f5 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f5,
	0,
	0
};
static const unsigned sparc_limited_fp_f6 [] = { (1 << REG_F6), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f6 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f6,
	0,
	0
};
static const unsigned sparc_limited_fp_f7 [] = { (1 << REG_F7), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f7 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f7,
	0,
	0
};
static const unsigned sparc_limited_fp_f8 [] = { (1 << REG_F8), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f8 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f8,
	0,
	0
};
static const unsigned sparc_limited_fp_f9 [] = { (1 << REG_F9), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f9 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f9,
	0,
	0
};
static const unsigned sparc_limited_fp_f10 [] = { (1 << REG_F10), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f10 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f10,
	0,
	0
};
static const unsigned sparc_limited_fp_f11 [] = { (1 << REG_F11), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f11 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f11,
	0,
	0
};
static const unsigned sparc_limited_fp_f12 [] = { (1 << REG_F12), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f12 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f12,
	0,
	0
};
static const unsigned sparc_limited_fp_f13 [] = { (1 << REG_F13), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f13 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f13,
	0,
	0
};
static const unsigned sparc_limited_fp_f14 [] = { (1 << REG_F14), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f14 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f14,
	0,
	0
};
static const unsigned sparc_limited_fp_f15 [] = { (1 << REG_F15), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f15 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f15,
	0,
	0
};
static const unsigned sparc_limited_fp_f16 [] = { (1 << REG_F16), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f16 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f16,
	0,
	0
};
static const unsigned sparc_limited_fp_f17 [] = { (1 << REG_F17), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f17 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f17,
	0,
	0
};
static const unsigned sparc_limited_fp_f18 [] = { (1 << REG_F18), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f18 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f18,
	0,
	0
};
static const unsigned sparc_limited_fp_f19 [] = { (1 << REG_F19), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f19 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f19,
	0,
	0
};
static const unsigned sparc_limited_fp_f20 [] = { (1 << REG_F20), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f20 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f20,
	0,
	0
};
static const unsigned sparc_limited_fp_f21 [] = { (1 << REG_F21), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f21 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f21,
	0,
	0
};
static const unsigned sparc_limited_fp_f22 [] = { (1 << REG_F22), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f22 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f22,
	0,
	0
};
static const unsigned sparc_limited_fp_f23 [] = { (1 << REG_F23), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f23 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f23,
	0,
	0
};
static const unsigned sparc_limited_fp_f24 [] = { (1 << REG_F24), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f24 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f24,
	0,
	0
};
static const unsigned sparc_limited_fp_f25 [] = { (1 << REG_F25), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f25 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f25,
	0,
	0
};
static const unsigned sparc_limited_fp_f26 [] = { (1 << REG_F26), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f26 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f26,
	0,
	0
};
static const unsigned sparc_limited_fp_f27 [] = { (1 << REG_F27), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f27 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f27,
	0,
	0
};
static const unsigned sparc_limited_fp_f28 [] = { (1 << REG_F28), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f28 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f28,
	0,
	0
};
static const unsigned sparc_limited_fp_f29 [] = { (1 << REG_F29), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f29 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f29,
	0,
	0
};
static const unsigned sparc_limited_fp_f30 [] = { (1 << REG_F30), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f30 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f30,
	0,
	0
};
static const unsigned sparc_limited_fp_f31 [] = { (1 << REG_F31), 0 };
static const arch_register_req_t sparc_single_reg_req_fp_f31 = {
	arch_register_req_type_limited,
	&sparc_reg_classes[CLASS_sparc_fp],
	sparc_limited_fp_f31,
	0,
	0
};

const arch_register_t sparc_flags_regs[N_sparc_flags_REGS] = {
	{
		"y",
		&sparc_reg_classes[CLASS_sparc_flags],
		REG_Y,
		arch_register_type_ignore,
		&sparc_single_reg_req_flags_y
	},
};
const arch_register_t sparc_gp_regs[N_sparc_gp_REGS] = {
	{
		"g0",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_G0,
		arch_register_type_ignore,
		&sparc_single_reg_req_gp_g0
	},
	{
		"g1",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_G1,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_g1
	},
	{
		"g2",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_G2,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_g2
	},
	{
		"g3",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_G3,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_g3
	},
	{
		"g4",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_G4,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_g4
	},
	{
		"g5",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_G5,
		arch_register_type_ignore,
		&sparc_single_reg_req_gp_g5
	},
	{
		"g6",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_G6,
		arch_register_type_ignore,
		&sparc_single_reg_req_gp_g6
	},
	{
		"g7",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_G7,
		arch_register_type_ignore,
		&sparc_single_reg_req_gp_g7
	},
	{
		"o0",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_O0,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_o0
	},
	{
		"o1",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_O1,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_o1
	},
	{
		"o2",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_O2,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_o2
	},
	{
		"o3",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_O3,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_o3
	},
	{
		"o4",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_O4,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_o4
	},
	{
		"o5",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_O5,
		arch_register_type_caller_save,
		&sparc_single_reg_req_gp_o5
	},
	{
		"sp",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_SP,
		arch_register_type_ignore,
		&sparc_single_reg_req_gp_sp
	},
	{
		"o6",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_O7,
		arch_register_type_ignore,
		&sparc_single_reg_req_gp_o7
	},
	{
		"l0",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_L0,
		arch_register_type_none,
		&sparc_single_reg_req_gp_l0
	},
	{
		"l1",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_L1,
		arch_register_type_none,
		&sparc_single_reg_req_gp_l1
	},
	{
		"l2",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_L2,
		arch_register_type_none,
		&sparc_single_reg_req_gp_l2
	},
	{
		"l3",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_L3,
		arch_register_type_none,
		&sparc_single_reg_req_gp_l3
	},
	{
		"l4",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_L4,
		arch_register_type_none,
		&sparc_single_reg_req_gp_l4
	},
	{
		"l5",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_L5,
		arch_register_type_none,
		&sparc_single_reg_req_gp_l5
	},
	{
		"l6",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_L6,
		arch_register_type_none,
		&sparc_single_reg_req_gp_l6
	},
	{
		"l7",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_L7,
		arch_register_type_none,
		&sparc_single_reg_req_gp_l7
	},
	{
		"i0",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_I0,
		arch_register_type_none,
		&sparc_single_reg_req_gp_i0
	},
	{
		"i1",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_I1,
		arch_register_type_none,
		&sparc_single_reg_req_gp_i1
	},
	{
		"i2",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_I2,
		arch_register_type_none,
		&sparc_single_reg_req_gp_i2
	},
	{
		"i3",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_I3,
		arch_register_type_none,
		&sparc_single_reg_req_gp_i3
	},
	{
		"i4",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_I4,
		arch_register_type_none,
		&sparc_single_reg_req_gp_i4
	},
	{
		"i5",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_I5,
		arch_register_type_none,
		&sparc_single_reg_req_gp_i5
	},
	{
		"fp",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_FP,
		arch_register_type_ignore,
		&sparc_single_reg_req_gp_fp
	},
	{
		"i7",
		&sparc_reg_classes[CLASS_sparc_gp],
		REG_I7,
		arch_register_type_ignore,
		&sparc_single_reg_req_gp_i7
	},
};
const arch_register_t sparc_fp_regs[N_sparc_fp_REGS] = {
	{
		"f0",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F0,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f0
	},
	{
		"f1",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F1,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f1
	},
	{
		"f2",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F2,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f2
	},
	{
		"f3",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F3,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f3
	},
	{
		"f4",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F4,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f4
	},
	{
		"f5",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F5,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f5
	},
	{
		"f6",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F6,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f6
	},
	{
		"f7",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F7,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f7
	},
	{
		"f8",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F8,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f8
	},
	{
		"f9",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F9,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f9
	},
	{
		"f10",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F10,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f10
	},
	{
		"f11",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F11,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f11
	},
	{
		"f12",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F12,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f12
	},
	{
		"f13",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F13,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f13
	},
	{
		"f14",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F14,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f14
	},
	{
		"f15",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F15,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f15
	},
	{
		"f16",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F16,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f16
	},
	{
		"f17",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F17,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f17
	},
	{
		"f18",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F18,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f18
	},
	{
		"f19",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F19,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f19
	},
	{
		"f20",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F20,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f20
	},
	{
		"f21",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F21,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f21
	},
	{
		"f22",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F22,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f22
	},
	{
		"f23",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F23,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f23
	},
	{
		"f24",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F24,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f24
	},
	{
		"f25",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F25,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f25
	},
	{
		"f26",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F26,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f26
	},
	{
		"f27",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F27,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f27
	},
	{
		"f28",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F28,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f28
	},
	{
		"f29",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F29,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f29
	},
	{
		"f30",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F30,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f30
	},
	{
		"f31",
		&sparc_reg_classes[CLASS_sparc_fp],
		REG_F31,
		arch_register_type_caller_save,
		&sparc_single_reg_req_fp_f31
	},
};


void sparc_register_init(void)
{
	sparc_reg_classes[CLASS_sparc_flags].mode = mode_Bu;
	sparc_reg_classes[CLASS_sparc_gp].mode = mode_Iu;
	sparc_reg_classes[CLASS_sparc_fp].mode = mode_D;

}
