/**
 * @file
 * @brief Contains additional external requirements defs for external includes.
 * @note   DO NOT EDIT THIS FILE, your changes will be lost.
 *         Edit libfirm/ir/be/sparc/sparc_spec.pl instead.
 *         created by: libfirm/ir/be/scripts/generate_regalloc_if.pl libfirm/ir/be/sparc/sparc_spec.pl libfirm/ir/be/sparc
 * @date   Tue May  4 15:35:32 2010
 */
#ifndef FIRM_BE_SPARC_GEN_SPARC_REGALLOC_IF_H
#define FIRM_BE_SPARC_GEN_SPARC_REGALLOC_IF_H

#include "../bearch.h"
#include "sparc_nodes_attr.h"

enum reg_sparc_flags_indices {
	REG_Y,
	N_sparc_flags_REGS = 1
};

enum reg_sparc_gp_indices {
	REG_G0,
	REG_G1,
	REG_G2,
	REG_G3,
	REG_G4,
	REG_G5,
	REG_G6,
	REG_G7,
	REG_O0,
	REG_O1,
	REG_O2,
	REG_O3,
	REG_O4,
	REG_O5,
	REG_SP,
	REG_O7,
	REG_L0,
	REG_L1,
	REG_L2,
	REG_L3,
	REG_L4,
	REG_L5,
	REG_L6,
	REG_L7,
	REG_I0,
	REG_I1,
	REG_I2,
	REG_I3,
	REG_I4,
	REG_I5,
	REG_FP,
	REG_I7,
	N_sparc_gp_REGS = 32
};

enum reg_sparc_fp_indices {
	REG_F0,
	REG_F1,
	REG_F2,
	REG_F3,
	REG_F4,
	REG_F5,
	REG_F6,
	REG_F7,
	REG_F8,
	REG_F9,
	REG_F10,
	REG_F11,
	REG_F12,
	REG_F13,
	REG_F14,
	REG_F15,
	REG_F16,
	REG_F17,
	REG_F18,
	REG_F19,
	REG_F20,
	REG_F21,
	REG_F22,
	REG_F23,
	REG_F24,
	REG_F25,
	REG_F26,
	REG_F27,
	REG_F28,
	REG_F29,
	REG_F30,
	REG_F31,
	N_sparc_fp_REGS = 32
};


enum reg_classes {
	CLASS_sparc_flags = 0,
	CLASS_sparc_gp = 1,
	CLASS_sparc_fp = 2,
	N_CLASSES = 3
};


extern const arch_register_t sparc_flags_regs[N_sparc_flags_REGS];
extern const arch_register_t sparc_gp_regs[N_sparc_gp_REGS];
extern const arch_register_t sparc_fp_regs[N_sparc_fp_REGS];


extern arch_register_class_t sparc_reg_classes[N_CLASSES];

void sparc_register_init(void);
unsigned sparc_get_n_regs(void);

#endif
